AppTitle "Demon Attack"

;Global LevelStart,UnlimitedLives
;Repeat
;	le$=Input$("Please select level to start (1-6): ")
;	LevelStart=le$
;Until LevelStart>=1 And LevelStart<=6

;Repeat
;	u$=Input$("Want unlimited lives? (y/n) ")
;Until u$="y" Or u$="Y" Or u$="n" Or u$="N"
;If u$="y" Or u$="Y" Then UnlimitedLives=True Else UnlimitedLives=False

SeedRnd MilliSecs()
Graphics 640,480,16,2
Global FrameTimer=CreateTimer(60)

;TYPES
Type ExploType
	Field x,y,t,f,ft,ftm
End Type

Type PlayerShotType
	Field x,y,t
End Type

Type DebrisType
	Field x#,y#,mx#,my#,t,f,ft,g,c
End Type

Type EnemyType
	Field x#,y#,mx#,my#,hp,f,ft,t,fdraw,mxtimer,mytimer,shooting
	Field x2#,y2#,ox#,oy#,formation,cycle#
End Type

Type BoundBomberType
	Field x#,y#,mx#,my#,hp,f,ft,fdraw,mxtimer,mytimer
	Field link,exist,manip
End Type

Type StarType
	Field x#,y#,my#,t
End Type

Type SpaceBombType
	Field x#,y#,mx#,my#,f,ft,t      ;t=1 (space bomb)  t=2 (base bomb)
End Type

Type MoonBombType
	Field x#,y#,mx#,my#,t,f,ft
End Type

Type TickerTapeType
	Field x#,y#,mx#,my#,t,f,ft,d
End Type

;GRAPHICS
;Fonts
Global SmallFont=LoadFont("Arial",12,True,False,False)
Global MediumFont=LoadFont("Arial",24,True,False,False)
Global LargeFont=LoadFont("Arial",36,True,False,False)

;Test Pixel
Global testpixel=CreateImage(1,1)
SetBuffer ImageBuffer(testpixel)
Color 255,255,255:Plot 0,0
SetBuffer BackBuffer()
;Explosions and Fire  (Explos 6=big explo, #9=Really big,  #10 and #11 are nukes)
Dim ExploFrames(11),ExploImage(11),FireImage(2) ;1-8 regular explosions  9-10 nukes
For a=1 To 11:Read ExploFrames(a):Next
Data 10,8,23,10,16,26,24,22,26,21,28
ExploImage(1)=LoadAnimImage("Gfx\Explosion 1 64x64x10.png",64,64,0,ExploFrames(1))
ExploImage(2)=LoadAnimImage("Gfx\Explosion 2 180x180x8.png",180,180,0,ExploFrames(2))
ExploImage(3)=LoadAnimImage("Gfx\Explosion 3 64x64x23.png",64,64,0,ExploFrames(3))
ExploImage(4)=LoadAnimImage("Gfx\Explosion 4 61x61x10.png",61,61,0,ExploFrames(4))
ExploImage(5)=LoadAnimImage("Gfx\Explosion 5 100x100x16.png",100,100,0,ExploFrames(5))
ExploImage(6)=LoadAnimImage("Gfx\Explosion 6 256x256x26.png",256,256,0,ExploFrames(6))
ExploImage(7)=LoadAnimImage("Gfx\Explosion 7 80x80x24.png",80,80,0,ExploFrames(7))
ExploImage(8)=LoadAnimImage("Gfx\Explosion 8 64x64x22.png",64,64,0,ExploFrames(8))
ExploImage(9)=LoadAnimImage("Gfx\Explosion 9 512x512x26.png",512,512,0,ExploFrames(9))
ExploImage(10)=LoadAnimImage("Gfx\Nuke 1 80x96x21.png",80,96,0,ExploFrames(10)):HandleImage ExploImage(10),39,95
ExploImage(11)=LoadAnimImage("Gfx\Nuke 2 64x96x28.png",64,96,0,ExploFrames(11)):HandleImage ExploImage(11),31,95
For a=1 To 9:MidHandle ExploImage(a):Next
FireImage(1)=LoadAnimImage("Gfx\Fire 30x60x33.png",30,60,0,33):HandleImage FireImage(1),14,59
FireImage(2)=LoadAnimImage("Gfx\Fire 60x60x33.png",60,60,0,33):HandleImage FireImage(2),29,59
;Player
Global EarthImage=LoadImage("Gfx\Earth.png"):MidHandle EarthImage
Global MoonSurfaceImage=LoadImage("Gfx\Moon Surface.jpg")
Global PlayerGunGlowsImage=LoadAnimImage("Gfx\Player Gun Glows.png",60,60,0,12):MidHandle PlayerGunGlowsImage
Global PlayerGunImage=LoadImage("Gfx\Player Gun.png"):HandleImage PlayerGunImage,14,48
Global PlayerShotImage=LoadAnimImage("Gfx\Player Shot.png",20,49,0,5):HandleImage PlayerShotImage,9,0
Global StudImage=LoadImage("Gfx\Stud.png"):HandleImage StudImage,174,479
Global BloodyHandImage=LoadImage("Gfx\Bloody Hand.jpg")
Global SkyImage=LoadImage("Gfx\Sky.png")
Global CityFarImage=LoadImage("Gfx\Cityscape - far.png")
Global CityNearImage=LoadImage("Gfx\Cityscape - near.png")
;Debris 
Dim DebrisColor(6,11),TickerTapeImage(3)
For a=1 To 6:For b=1 To 11:Read DebrisColor(a,b):Next:Next
Data 1,2,7,7,7,7,7,3,3,1,9
Data 1,9,7,7,10,10,10,7,2,8,3
Data 1,7,2,2,3,3,3,9,1,10,7
Data 1,3,9,9,8,8,8,1,7,3,2
Data 1,10,3,3,9,9,9,8,9,7,10
Data 1,8,8,8,1,1,1,10,10,2,1
Global DebrisImage=LoadAnimImage("Gfx\Debris.png",9,9,0,270):MidHandle DebrisImage
For a=1 To 3:TickerTapeImage(a)=LoadAnimImage("Gfx\Ticker Tape - "+a+".png",30,11,0,6):MidHandle TickerTapeImage(a):Next
      ;Colors: 1=yellow,2=orange,3=red,4=dark grey,5=med grey,6=light grey,7=green 8=cyan 9=blue 10=purple
;Enemies
Dim LargeAmoebaImage(6),MediumAmoebaImage(6),SmallAmoebaImage(6),BoundBomberImage(6),WingedWarriorImage(6),TentacledTerroristImage(6)
Dim SpaceFrontImage(6),SpaceMiddleImage(6),SpaceRearImage(6)
Global SuicideDefenderImage=LoadAnimImage("Gfx\Enemy - Suicide Defender.png",48,35,0,20):MidHandle SuicideDefenderImage
For a=1 To 6
	LargeAmoebaImage(a)=LoadAnimImage("Gfx\Enemy - Amoeba - Large - "+a+".png",120,81,0,8):MidHandle LargeAmoebaImage(a)
	MediumAmoebaImage(a)=LoadAnimImage("Gfx\Enemy - Amoeba - Medium - "+a+".png",80,58,0,6):MidHandle MediumAmoebaImage(a)
	SmallAmoebaImage(a)=LoadAnimImage("Gfx\Enemy - Amoeba - Small - "+a+".png",44,44,0,4):MidHandle SmallAmoebaImage(a)
	BoundBomberImage(a)=LoadAnimImage("Gfx\Enemy - Bound Bomber - "+a+".png",88,47,0,20):MidHandle BoundBomberImage(a)
	TentacledTerroristImage(a)=LoadAnimImage("Gfx\Enemy - Tentacled Terrorist - "+a+".png",30,44,0,5):MidHandle TentacledTerroristImage(a)
	WingedWarriorImage(a)=LoadAnimImage("Gfx\Enemy - Winged Warrior - "+a+".png",127,70,0,35):MidHandle WingedWarriorImage(a)
	SpaceFrontImage(a)=LoadAnimImage("Gfx\Enemy - Space - Front - "+a+".png",66,55,0,30):MidHandle SpaceFrontImage(a)
	SpaceMiddleImage(a)=LoadAnimImage("Gfx\Enemy - Space - Middle - "+a+".png",66,55,0,20):MidHandle SpaceMiddleImage(a)
	SpaceRearImage(a)=LoadAnimImage("Gfx\Enemy - Space - Rear - "+a+".png",91,71,0,4):MidHandle SpaceRearImage(a)
Next
;Enemy Weapons
Global PelletPulverizerImage=LoadImage("Gfx\Pellet Pulverizer.png"):MidHandle PelletPulverizerImage
Global JaggedJuggernautImage=LoadAnimImage("Gfx\Jagged Juggernaut.png",29,29,0,6):MidHandle JaggedJuggernautImage
Global GuidedDetonatorImage=LoadAnimImage("Gfx\Guided Detonator.png",19,19,0,2):MidHandle GuidedDetonatorImage
Global BaseBombImage=LoadAnimImage("Gfx\Base Bomb.png",19,19,0,3):MidHandle BaseBombImage
Global SpaceBombImage=LoadAnimImage("Gfx\Space Bomb.png",9,9,0,2):MidHandle SpaceBombImage
;Misc graphics
;Starfield
Dim StarImage(5)
StarImage(1)=LoadImage("Gfx\Star-1.png")
StarImage(2)=LoadImage("Gfx\Star-2.png")
StarImage(3)=LoadImage("Gfx\Star-3.png")
StarImage(4)=LoadImage("Gfx\Star-4.png")
StarImage(5)=LoadImage("Gfx\Star-5.png")
For a=1 To 5:MidHandle StarImage(a):Next
;Demon Bases (images and variables)
;Base 1
Dim B1FireFrame(2)
Global B1FireTimer,B1RotWindPos
Global B1ArmorImage=LoadImage("Gfx\Demon Bases\B1 - Armor.png")
Global B1HeadImage=LoadImage("Gfx\Demon Bases\B1 - Head.png")
Global B1LeftEndImage=LoadImage("Gfx\Demon Bases\B1 - Left End.png")
Global B1RightEndImage=LoadImage("Gfx\Demon Bases\B1 - Right End.png")
Global B1RotatingWindowImage=LoadImage("Gfx\Demon Bases\B1 - Rotating Window.png")
Global B1MouthInteriorImage=LoadImage("Gfx\Demon Bases\B1 - Mouth Interior.png")
;Base 2
Dim B2FireFrame(3),B2WindowX(17),B2WindowY(17),B2WindowFrame(17)
For a=1 To 17:Read B2WindowX(a),B2WindowY(a):B2WindowY(a)=B2WindowY(a)-20:Next
Data 227,171, 233,151, 253,145, 258,165, 280,131, 303,133, 297,100, 325,119, 326,102, 342,134, 367,111, 363,136, 367,153, 386,133, 391,151, 375,174, 396,175
Global B2FireTimer,B2RotShieldPos
Global B2CityAndHornsImage=LoadImage("Gfx\Demon Bases\B2 - City and Horns.png")
Global B2CityWindowsImage=LoadAnimImage("Gfx\Demon Bases\B2 - City Windows.png",4,5,0,3):MidHandle B2CityWindowsImage
Global B2LeftHornImage=LoadImage("Gfx\Demon Bases\B2 - Left Horn.png")
Global B2RightHornImage=LoadImage("Gfx\Demon Bases\B2 - Right Horn.png")
Global B2RotatingShieldImage=LoadImage("Gfx\Demon Bases\B2 - Rotating Shield.png")
;Base 3
Dim B3FireFrame(15),B3GunExist(2),B3GunsTimer(2),B3GunX(2),B3WindowX(32),B3WindowY(32),B3WindowColor(32)
B3GunX(1)=25:B3GunX(2)=544
For a=1 To 32:Read B3WindowX(a),B3WindowY(a):Next
Data 125,127, 111,133, 97,143, 128,137, 120,143, 109,151, 102,157, 94,162, 119,153, 99,170, 130,156, 122,163, 112,168, 136,168, 126,177, 146,173
Data 524,124, 549,161, 548,173, 537,174, 528,168, 528,154, 525,145, 518,141, 515,151, 518,161, 509,158, 513,174, 506,171, 499,166, 494,158, 501,149
Global B3FireTimer,B3RotWindPos,B3RotShieldPos
Global B3HeadImage=LoadImage("Gfx\Demon Bases\B3 - Head.png")
Global B3LeftEndImage=LoadImage("Gfx\Demon Bases\B3 - Left End.png")
Global B3LeftGunImage=LoadImage("Gfx\Demon Bases\B3 - Left Gun.png")
Global B3RightEndImage=LoadImage("Gfx\Demon Bases\B3 - Right End.png")
Global B3RightGunImage=LoadImage("Gfx\Demon Bases\B3 - Right Gun.png")
Global B3RotatingShieldImage=LoadImage("Gfx\Demon Bases\B3 - Rotating Shield.png")
Global B3RotatingWindowImage=LoadImage("Gfx\Demon Bases\B3 - Rotating Window.png")
;Base 4
Dim B4ShieldX(50),B4ShieldY(50),B4ShieldType(50),B4ShieldTimer(50),B4WindowX(40),B4WindowY(40),B4WindowFrame(40),B4WindowTimer(40)
For a=1 To 40:Read B4WindowX(a),B4WindowY(a):Next
Data 200,67, 193,73, 200,86, 257,57, 276,39, 309,28, 341,16, 352,35, 379,57, 431,51, 443,57, 438,67, 451,77, 444,96, 417,95, 419,77
Data 398,72, 404,59, 369,65, 336,63, 331,47, 310,46, 306,68, 293,56, 290,31, 279,68, 265,86, 244,91, 236,73, 241,56, 223,96
Data 217,117, 241,107, 255,123, 295,87, 357,85, 384,94, 394,124, 432,128, 451,115
Global B4HeartFrame,B4HeartTimer,B4HeartCycle
Global B4HeartImage=LoadAnimImage("Gfx\Demon Bases\B4 - Heart.png",126,55,0,4)
Global B4ShieldPiecesImage=LoadAnimImage("Gfx\Demon Bases\B4 - Shield Pieces.png",50,50,0,3):MidHandle B4ShieldPiecesImage
Global B4CityAndHornsImage=LoadImage("Gfx\Demon Bases\B4 - City and Horns.png")
Global B4ArmorImage=LoadImage("Gfx\Demon Bases\B4 - Armor.png")
Global B4CityWindowsImage=LoadAnimImage("Gfx\Demon Bases\B4 - City Windows.png",3,3,0,4):MidHandle B4CityWindowsImage
;Base 5
Global B5BubblingFrame,B5BubblingTimer,B5GeneratorFrame,B5GeneratorTimer,B5RotWindPos,B5RotShieldPos
Dim B5ProtectorAng#(2,16),B5ProtectorX(2,16),B5ProtectorY(2,16),B5EyeBX#(5),B5EyeBY#(5),B5EyeMX#(5),B5EyeMY#(5),B5EyeRX#(5),B5EyeRY#(5),B5EyeTimer(5),B5OddAngle(2),B5GeneratorExist(2)
For a=1 To 5:Read B5EyeBX(a),B5EyeBY(a):Next
Data 201,102,215,51,306,56,410,87,468,88
Global B5BubblingImage=LoadAnimImage("Gfx\Demon Bases\B5 - Bubbling.png",135,16,0,4)
Global B5ExtraShieldImage=LoadImage("Gfx\Demon Bases\B5 - Extra Shield.png")
Global B5EyeballImage=LoadImage("Gfx\Demon Bases\B5 - Eyeball.png"):MidHandle B5EyeBallImage
Global B5GeneratorDefenderImage=LoadImage("Gfx\Demon Bases\B5 - Generator Defender.png")
Global B5HeadImage=LoadImage("Gfx\Demon Bases\B5 - Head.png")
Global B5LeftSideImage=LoadImage("Gfx\Demon Bases\B5 - Left Side.png")
Global B5RightSideImage=LoadImage("Gfx\Demon Bases\B5 - Right Side.png")
Global B5RotatingGeneratorImage=LoadAnimImage("Gfx\Demon Bases\B5 - Rotating Generator Frames.png",59,59,0,6)
Global B5RotatingShieldImage=LoadImage("Gfx\Demon Bases\B5 - Rotating Shield.png")
Global B5RotatingWindowImage=LoadImage("Gfx\Demon Bases\B5 - Rotating Window.png")
Global B5YellowEyeScreenImage=LoadImage("Gfx\Demon Bases\B5 - Yellow Eye Screen.png")
Global B5EyeGlintImage=LoadImage("Gfx\Demon Bases\B5 - Eye glint.png"):MidHandle B5EyeGlintImage
;Base 6
;Global B6=LoadImage("Gfx\Demon Bases\B6 - .png")
Dim B6FireFrame(6),GunsX(2,2),GunsY(2,2),GunsExist(2,2),GunsTimer(2,2),GunsShooting(2,2),GenX(2),GenExist(2),B6ShieldX(50),B6ShieldY(50),B6ShieldType(50),B6ShieldTimer(50)
GenX(1)=169:GenX(2)=414
For a=1 To 2:For b=1 To 2:Read GunsX(a,b),GunsY(a,b):Next:Next
Data 92,153,42,120,521,153,571,120
Global B6FireTimer,B6GenFrame,B6GenTimer,B6RotWindPos,B6WindDir,B6WindDirTimer
Global B6HeadAndHornsImage=LoadImage("Gfx\Demon Bases\B6 - Head and Horns.png")
Global B6LeftEndImage=LoadImage("Gfx\Demon Bases\B6 - Left End.png")
Global B6LeftGunImage=LoadImage("Gfx\Demon Bases\B6 - Left Gun.png")
Global B6RightEndImage=LoadImage("Gfx\Demon Bases\B6 - Right End.png")
Global B6RightGunImage=LoadImage("Gfx\Demon Bases\B6 - Right Gun.png")
Global B6RotatingWindowImage=LoadImage("Gfx\Demon Bases\B6 - Rotating Window.png")
Global B6ReactorGuardImage=LoadImage("Gfx\Demon Bases\B6 - Reactor Guard.png")
Global B6GlowingGeneratorImage=LoadAnimImage("Gfx\Demon Bases\B6 - Glowing Generator.png",57,29,0,4)
Global B6ShieldPiecesImage=LoadAnimImage("Gfx\Demon Bases\B6 - Red Stuff.png",50,50,0,3):MidHandle B6ShieldPiecesImage
;TITLE
Global TitleHeaderImage=LoadImage("Gfx\Title - Header.png")
;VARIABLES
;Player
Global px#,py#,ChargeStage,ChargeTimer,GameStage,GameLevel,FireDown,ScreenShake,DeathTimer,Blink
Global NextStageTimer,Lives,Score,NextBonusLife,BasesOnly,StartOver,Cheat
StartOver=True
;MoonScape
Global EarthX,EarthY,MoonPos#
Global Wave,DemonsLeft
Dim EnemyCo(11)
;Enemies
Dim BoundBomber.BoundBomberType(3,5),ReactorY(6),NumDemons(6,4),MaxEnemiesOnScreen(6,4)  ;1=ww 2=tt 3=amoebae 4=bb
For a=1 To 3:For b=1 To 5:BoundBomber.BoundBomberType(a,b)=New BoundBomberType:Next:Next
Dim DemonHP(6,11,2)  ;level,type (2=ww 3=btt 4=ftt 5/6/7=amoebae 8=bb, 9=drag 10=df 11=jelly)
Global SpaceEnemyPattern,SpaceEnemyPos,NumSpaceEnemies
Dim instf(11),instft(11),instfm(11),instftm(11)
For a=1 To 11:Read instfm(a),instftm(a):Next
Data 4,4, 7,8, 5,4, 5,4, 8,7, 6,5, 4,3, 4,2, 6,5, 4,2, 4,4
For a=1 To 6:Read ReactorY(a):Next
Data 130,150,140,110,115,155
For a=1 To 6:For b=1 To 4:Read NumDemons(a,b),MaxEnemiesOnScreen(a,b):Next:Next
Data 8,2, 6,1, 3,1, 5,1
Data 10,3, 6,1, 3,1, 6,1
Data 12,3, 7,2, 4,1, 7,1 
Data 14,3, 7,2, 4,1, 8,1
Data 16,4, 8,2, 5,1, 5,2
Data 18,4, 9,2, 5,2, 7,2
For a=1 To 6:For b=2 To 11:For c=1 To 2:Read DemonHP(a,b,c):Next:Next:Next
;    ww     btt    ftt     lam     mam    sam     bb       drg     df     jelly
Data 1,3,   1,1,   1,1,    4,6,    1,3,   1,1,    1,2,     1,2,    1,2,   5,8
Data 2,5,   1,2,   1,1,    5,7,    2,3,   1,2,    2,4,     1,2,    1,2,   7,10 
Data 3,8,   1,2,   1,2,    5,8,    3,4,   1,3,    3,5,     1,3,    1,3,   9,12
Data 4,12,   1,3,   1,3,    6,10,   3,5,   2,3,    4,7,    1,4,    1,4,   10,15
Data 5,15,   1,4,   1,4,    8,11,   3,6,   2,3,    3,6,     1,4,    1,4,   11,16
Data 5,15,  1,4,   2,4,    6,9,     3,6,   2,4,    3,6,     1,4,    1,4,   12,17

;AUDIO
Global HeartBeatTimer
Dim InsultSound(5),EvilLaughSound(5),BaseTauntSound(5),BaseDestroyedPutdownSound(6),ExplosionSound(5)
Global BaseDestroyedSong=LoadSound("Audio\Victory - Demon Base Destroyed.mp3"):SoundVolume BaseDestroyedSong,0.7
Global Tune1Song=LoadSound("Audio\Tune - 1.mp3"):SoundVolume Tune1Song,0.7
Global Tune2Song=LoadSound("Audio\Tune - 2.mp3"):SoundVolume Tune2Song,0.7
For a=1 To 5
	InsultSound(a)=LoadSound("Audio\Insult - "+a+".mp3"):SoundVolume InsultSound(a),0.7
	EvilLaughSound(a)=LoadSound("Audio\Laugh - "+a+".mp3"):SoundVolume EvilLaughSound(a),0.7
	BaseTauntSound(a)=LoadSound("Audio\Base Intro Insult - "+a+".mp3"):SoundVolume BaseTauntSound(a),0.7
	BaseDestroyedPutdownSound(a)=LoadSound("Audio\Base Destroyed Putdown - "+a+".mp3"):SoundVolume BaseDestroyedPutdownSound(a),0.7
	ExplosionSound(a)=LoadSound("Audio\Explosion - "+a+".mp3"):SoundVolume ExplosionSound(a),0.4
Next
Global NoooooSound=LoadSound("Audio\Nooooo.mp3"):SoundVolume NoooooSound,0.8
Global BeepSound=LoadSound("Audio\Beep.mp3"):SoundVolume BeepSound,0.05
Global PlayerGunCharging1Sound=LoadSound("Audio\Player Gun Charging 1.wav"):SoundVolume PlayerGunCharging1Sound,0.2
Global PlayerGunCharging2Sound=LoadSound("Audio\Player Gun Charging 2.wav"):SoundVolume PlayerGunCharging2Sound,0.2:LoopSound PlayerGunCharging2Sound
Global HeartBeatSound=LoadSound("Audio\HeartBeat.wav"):SoundVolume HeartBeatSound,0.3
Global SquishSound=LoadSound("Audio\Squish.mp3"):SoundVolume SquishSound,0.8
Global EnemyFireSound=LoadSound("Audio\Fire - Enemy.mp3"):SoundVolume EnemyFireSound,0.3
Global PlayerFireSound=LoadSound("Audio\Fire - Player.mp3"):SoundVolume PlayerFireSound,0.3
Global PlayerSuperFireSound=LoadSound("Audio\Super Fire - Player.mp3"):SoundVolume PlayerSuperFireSound,0.5
Global SuperChargeChannel,SuperChargeSoundStage,VictorySongChannel
Global VictorySong=LoadSound("Audio\Victory - Game Won.mp3"):SoundVolume VictorySong,0.7
Global YouLoseSong=LoadSound("Audio\You Lose.mp3"):SoundVolume YouLoseSong,0.7

TitleImage=LoadImage("Gfx\Demon Attack Title.jpg")
PlaySound YouLoseSong
Cls
DrawBlock TitleImage,0,0
Flip
Repeat
Until KeyDown(57)
FreeImage TitleImage

InitializeVariables
.title_screen
If StartOver=True Then TitleScreen
If BasesOnly=True Then py=479:GameStage=3:NextStageTimer=700:Lives=6
ResetDemonBases(False)
NextLevel
SetupStars

;VictoryScreen
;GameOverScreen

Repeat
	kk=GetKey()
	ex=320:ey=240
;	If kk=Asc("1") Then AddExplosion(ex,ey,1,5)
;	If kk=Asc("2") Then AddExplosion(ex,ey,2,5)
;	If kk=Asc("3") Then AddExplosion(ex,ey,3,5)
;	If kk=Asc("4") Then AddExplosion(ex,ey,4,5)
;	If kk=Asc("5") Then AddExplosion(ex,ey,5,5)
;	If kk=Asc("6") Then AddExplosion(ex,ey,6,5)
;	If kk=Asc("7") Then AddExplosion(ex,ey,7,5)
;	If kk=Asc("8") Then AddExplosion(ex,ey,8,5)
;	If kk=Asc("9") Then AddExplosion(ex,ey,9,7)
;	If kk=Asc("0") Then AddExplosion(ex,419,10,5)
;	If kk=Asc("-") Then AddExplosion(ex,419,11,5)
;	If kk=Asc("d") Then DestroyDemonbase
	
	
	If DeathTimer<=150 And NextStageTimer=0 Then
		If KeyDown(205) Then px=px+10
		If KeyDown(203) Then px=px-10
		
		If NextStageTimer=0 Then
			If KeyDown(57) Then 
				If FireDown=False Then
					FireDown=True
					AddPlayerShot(px,py-40,0)
					;AddPlayerShot(px-10,py-40,0):AddPlayerShot(px-20,py-40,0):AddPlayerShot(px+20,py-40,0):AddPlayerShot(px+10,py-40,0)
					PlaySound PlayerFireSound
				EndIf
				If GameStage=3 Or BasesOnly=True Then
					ChargeTimer=ChargeTimer+1
					If SuperChargeSoundStage=1 And ChannelPlaying(SuperChargeChannel)=False Then SuperChargeChannel=PlaySound(PlayerGunCharging2Sound):SuperChargeSoundStage=2
					If ChargeTimer>=30 Then
						ChargeTimer=0
						ChargeStage=ChargeStage+1
						If ChargeStage=1 Then SuperChargeChannel=PlaySound(PlayerGunCharging1Sound):SuperChargeSoundStage=1
						If ChargeStage>4 Then ChargeStage=4
					EndIf
				EndIf
			EndIf
		EndIf

		If Not KeyDown(57) Then 
			FireDown=False
				If ChargeStage>0 Then 
					AddPlayerShot(px,py-40,ChargeStage)
					StopChannel SuperChargeChannel:SuperChargeSoundStage=0
					If ChargeStage=4 Then 
						PlaySound PlayerSuperFireSound Else PlaySound PlayerFireSound
					EndIf
				EndIf
			ChargeStage=0:ChargeTimer=0
		EndIf
	EndIf

	If kk=Asc("c") Or kk=Asc("C") Then
		If Cheat=False Then Cheat=True Else Cheat=False
		If Cheat=True Then Score=0
	EndIf

	If kk=Asc("p") Or kk=Asc("P") Then
		Repeat
			kk=GetKey()
		Until kk=Asc("p")
	EndIf

	WaitTimer(FrameTimer)
	Cls
		Origin 0,0
		If ScreenShake>0 Then ScreenShake=ScreenShake-1
		For shake=1 To 10
			If ScreenShake>10*shake Then Origin Rand(-shake,shake),Rand(-shake,shake)
		Next
		
		If BasesOnly=False Then
		If GameStage=1
			If NextStageTimer=0 Then 
				UpdateStarField(0)
				DrawMoonScape(MoonPos)
				HandleMoonWaves
			Else
				NextStageTimer=NextStageTimer-1
				If NextStageTimer>900 Then UpdateDemonBase(GameLevel-1,0,False):UpdateStarField(0)
				If NextStageTimer>900 And NextStageTimer<=1200 Then 
					ScreenShake=200
					UpdateStarField(0)
					If Rand(1,10)=1 Then 
						xx=320+Rand(-160,160):yy=ReactorY(GameLevel-1)+Rand(-100,100)
						AddExplosion(xx,yy,6,Rand(3,6))
						PlaySound ExplosionSound(4)
						AddGreyDebrisExplosion(xx,yy,Rand(20,40),6,9)
					EndIf
					If Rand(1,30)=1 Then AddExplosion(320+Rand(-220,222),ReactorY(GameLevel-1)+Rand(-100,100),9,Rand(7,10)):PlaySound ExplosionSound(5)
				EndIf
				If NextStageTimer<=900 And NextStageTimer>500 Then UpdateStarField(0)
				If NextStageTimer<=500 Then 
					If NextStageTimer=450 Then PlaySound BaseDestroyedSong
					If py>419 Then py=py-1
					UpdateStarField(-1)
					RocketThrust
					If MoonPos>0 And NextStageTimer<=300 Then MoonPos=MoonPos-1
					DrawMoonScape(MoonPos)
				EndIf
				If NextStageTimer=0 And GameLevel=7 Then VictoryScreen:Goto Title_Screen
			EndIf
		EndIf
		If GameStage=2 Then
			If NextStageTimer=0 Then 
				HandleSpaceWaves(SpaceEnemyPos):UpdateStarField(1)
				If SpaceEnemyPos<0 Then SpaceEnemyPos=SpaceEnemyPos+5 Else SpaceEnemyPos=0
				If NumSpaceEnemies=0 Then NextStage(3)
			Else
				NextStageTimer=NextStageTimer-1
				If NextStageTimer>500 Then UpdateStarField(0)
				If NextStageTimer<=500 Then
					If NextStageTimer=500 Then PlaySound Tune1Song
					UpdateStarField(1)
					RocketThrust
					If MoonPos<300 Then MoonPos=MoonPos+1
				EndIf
				If NextStageTimer<100 Then
					If py<479 Then py=py+1
				EndIf
				DrawMoonScape(MoonPos)
				If NextStageTimer=1 Then SetUpSpaceWaves:HandleSpaceWaves(SpaceEnemyPos)
			EndIf
		EndIf
		If GameStage=3 Then 
			If NextStageTimer=0 Then
				UpdateStarField(0)
				UpdateDemonBase(GameLevel,0,True)
			Else
				NextStageTimer=NextStageTimer-1
				If NextStageTimer<=500 Then RocketThrust
				If NextStageTimer=500 Then PlaySound Tune2Song
				If NextStageTimer>500 Or NextStageTimer<100 Then UpdateStarField(1)
				If NextStageTimer>=100 And NextStageTimer<=500 Then UpdateStarField(3)
				If NextStageTimer>=400 And NextStageTimer<=500 Then
					If py>419 Then py=py-1
				EndIf
				If NextStageTimer<100 Then
					If py<479 Then py=py+1
				EndIf
				If NextStageTimer<=100 Then 
					UpdateDemonBase(GameLevel,-NextStageTimer*4,False)
					If NextStageTimer=65 Then PlaySound BaseTauntSound(Rand(1,5))
				EndIf
			EndIf
		EndIf
		EndIf
		
		If BasesOnly=True Then
			If NextStageTimer=0 Then
				UpdateStarField(0)
				UpdateDemonBase(GameLevel,0,True)
			Else
				NextStageTimer=NextStageTimer-1
				If NextStageTimer>900 Then UpdateDemonBase(GameLevel-1,0,False):UpdateStarField(0)
				If NextStageTimer>900 And NextStageTimer<=1200 Then 
					ScreenShake=200
					UpdateStarField(0)
					If Rand(1,10)=1 Then 
						xx=320+Rand(-160,160):yy=ReactorY(GameLevel-1)+Rand(-100,100)
						AddExplosion(xx,yy,6,Rand(3,6))
						PlaySound ExplosionSound(4)
						AddGreyDebrisExplosion(xx,yy,Rand(20,40),6,9)
					EndIf
					If Rand(1,30)=1 Then AddExplosion(320+Rand(-220,222),ReactorY(GameLevel-1)+Rand(-100,100),9,Rand(7,10)):PlaySound ExplosionSound(5)
				EndIf
				If NextStageTimer<=500 Then RocketThrust
				If NextStageTimer=500 And GameLevel<=6 Then PlaySound Tune2Song
				If NextStageTimer=500 And GameLevel>6 Then VictoryScreen
				If NextStageTimer>500 Or NextStageTimer<100 Then UpdateStarField(1)
				If NextStageTimer>=100 And NextStageTimer<=500 Then UpdateStarField(3)
				If NextStageTimer>=400 And NextStageTimer<=500 Then
					If py>419 Then py=py-1
				EndIf
				If NextStageTimer<100 Then
					If py<479 Then py=py+1
				EndIf
				If NextStageTimer<=100 Then 
					UpdateDemonBase(GameLevel,-NextStageTimer*4,False)
					If NextStageTimer=65 Then PlaySound BaseTauntSound(Rand(1,5))
				EndIf
		
			EndIf
		EndIf
		
		If NextStageTimer<>0 Then ChargeTimer=0:ChargeStage=0
		
		If NextStageTimer=0 Then
			HeartBeatTimer=HeartBeatTimer+1
			If HeartBeatTimer=60 Then
				HeartBeatTimer=0
				freq#=22000
				If GameStage=1 Then freq#=22000*(1+((Wave-1)*0.10))
				If GameStage=2 Then
					co=0:For Enemy.EnemyType=Each EnemyType:co=co+1:Next
					freq#=22000+((36-co)*250)				
				EndIf
				SoundPitch HeartBeatSound,freq:PlaySound HeartBeatSound
			EndIf
		EndIf
		
		If DeathTimer=150 Then 
			If UnlimitedLives=False And Cheat=False Then Lives=Lives-1
			If Lives<0 Then GameOverScreen:Goto title_screen
		EndIf
		
		UpdateHUD
		UpdateSpaceBombs
		UpdateMoonBombs
		UpdatePlayerShots
		UpdatePlayerGun
		UpdateEnemies
		UpdateDebris
		UpdateExplosions
		;Color 255,255,255
		;Text 50,50,nextstagetimer
	Flip

Until KeyDown(1)

Function GameOverScreen()
	PlaySound YouLoseSong
	Repeat
		Cls
		DrawBlock BloodyHandImage,0,0
		SetFont LargeFont
		Color 0,0,0
		Text 322,202,"Space to start over",True,False
		If BasesOnly=False Then Text 322,242,"'L' to start over at current level",True,False
		Text 322,282,"ESC to quit",True,False
		
		Color 255,255,255
		Text 320,200,"Space to start over",True,False
		If BasesOnly=False Then Text 320,240,"'L' to start over at current level",True,False
		Text 320,280,"ESC to quit",True,False
		Flip
		If KeyDown(57) Or KeyDown(38) Then 
			If KeyDown(38) And BasesOnly=True Then Goto nolevels
			If KeyDown(38) Then 
				StartOver=False:ss=GameLevel-1
			Else 
				StartOver=True:ss=0
			EndIf
			InitializeVariables
			GameLevel=ss
			ResetDemonBases(True)
			ClearEnemyBombsandDebris
			For Explo.ExploType=Each ExploType:Delete Explo:Next
			For PlayerShot.PlayerShotType=Each PlayerShotType:Delete PlayerShot:Next
			For Enemy.EnemyType=Each EnemyType:Delete Enemy:Next
			Return
			.nolevels
		EndIf
	
		If KeyDown(1) Then End
	Forever
End Function

Function VictoryScreen()
	For a=1 To 40:AddTickerTape(Rand(0,639),Rand(0,479),Rnd(-2,2),Rnd(1,3),Rand(1,3)):Next
	VictorySongChannel=PlaySound(VictorySong)
	scroll#=520:StudAngle=0
	CityScroll1#=0:CityScroll2#=0
	Repeat
		If KeyDown(1) Then End
		If KeyDown(57) Then
			InitializeVariables
			GameLevel=0
			ResetDemonBases(True)
			ClearEnemyBombsandDebris
			For TickerTape.TickerTapeType=Each TickerTapeType:Delete TickerTape:Next
			For Explo.ExploType=Each ExploType:Delete Explo:Next
			For PlayerShot.PlayerShotType=Each PlayerShotType:Delete PlayerShot:Next
			For Enemy.EnemyType=Each EnemyType:Delete Enemy:Next
			StopChannel VictorySongChannel
			StartOver=True
			Return
		EndIf
		
		If Rand(1,7)=1 Then AddTickerTape(Rand(0,639),-10,Rnd(-1,1),Rnd(0.5,3),Rand(1,3))
		
		If ChannelPlaying(VictorySongChannel)=False Then VictorySongChannel=PlaySound(VictorySong)
		
		VictoryTimer=VictoryTimer+1
		
		Cls
		DrawBlock SkyImage,0,0
		DrawImage CityFarImage,CityScroll2,0:DrawImage CityFarImage,CityScroll2-640,0
		DrawImage CityNearImage,CityScroll1,0:DrawImage CityNearImage,CityScroll1-640,0
		CityScroll1=CityScroll1+1
		CityScroll2=CityScroll2+0.25
		If CityScroll1>=640 Then CityScroll1=CityScroll1-640
		If CityScroll2>=640 Then CityScroll2=CityScroll2-640
		
		StudAngle=StudAngle+2
		If StudAngle>359 Then StudAngle=StudAngle-360
		DrawImage StudImage,400,500+(10*Sin(StudAngle))
		UpdateTickerTape
		Scroll=Scroll-0.25

		Color 255,0,0
		SetFont LargeFont
		Text 322,Scroll+2,"YOU STUD!!!",True,False
		SetFont MediumFont
		Text 322,Scroll+52,"MUCH DEMON ASS HAS BEEN KICKED TODAY,",True,False
		Text 322,Scroll+82,"AND THE EARTH OWES YOU A HUGE DEBT OF",True,False
		Text 322,Scroll+112,"GRATITUDE. WITH THE LAST DEMON BASE",True,False
		Text 322,Scroll+142,"BLOWN TO CHICLET SIZED PIECES, THE",True,False
		Text 322,Scroll+172,"THREAT IS OVER FOREVER.",True,False
		Text 322,Scroll+202,"SO KICK BACK AND CRACK OPEN A COLD ONE,",True,False
		Text 322,Scroll+232,"'CAUSE IT'S TIME FOR A DRUNKEN PARTY!!",True,False
		Text 322,Scroll+292,"THANKS FOR PLAYING!",True,False
		SetFont SmallFont
		Text 321,Scroll+311,"-Lysozyme",True,False
		SetFont MediumFont
		If Scroll+350>220 Then yy#=Scroll+350 Else yy=220
		Text 322,yy+2,"PRESS SPACE TO PLAY AGAIN",True,False
		Text 322,yy+32,"PRESS ESC TO QUIT",True,False

		
		Color 255,255,0
		SetFont LargeFont
		Text 320,Scroll,"YOU STUD!!!",True,False
		SetFont MediumFont
		Text 320,Scroll+50,"MUCH DEMON ASS HAS BEEN KICKED TODAY,",True,False
		Text 320,Scroll+80,"AND THE EARTH OWES YOU A HUGE DEBT OF",True,False
		Text 320,Scroll+110,"GRATITUDE. WITH THE LAST DEMON BASE",True,False
		Text 320,Scroll+140,"BLOWN TO CHICLET SIZED PIECES, THE",True,False
		Text 320,Scroll+170,"THREAT IS OVER FOREVER.",True,False
		Text 320,Scroll+200,"SO KICK BACK AND CRACK OPEN A COLD ONE,",True,False
		Text 320,Scroll+230,"'CAUSE IT'S TIME FOR A DRUNKEN PARTY!!",True,False
		Text 320,Scroll+290,"THANKS FOR PLAYING!",True,False
		SetFont SmallFont
		Text 320,Scroll+310,"-Lysozyme",True,False
		SetFont MediumFont
		If Scroll+350>220 Then yy#=Scroll+350 Else yy=220
		Text 320,yy,"PRESS SPACE TO PLAY AGAIN",True,False
		Text 320,yy+30,"PRESS ESC TO QUIT",True,False
		Flip
	Forever
End Function

Function TitleScreen()
	SetUpStars
	.mainmenu
	Choice=1:InstructionPage=1
	Repeat
		kk=GetKey()	
		If kk=Asc("1") Then BasesOnly=False:Goto done
		If kk=Asc("2") Then BasesOnly=True:Goto done
		If kk=Asc("3") Then Goto instructions
		
		WaitTimer(FrameTimer)
		Cls
		UpdateStarField(1)
		DrawImage TitleHeaderImage,0,15
		Color 255,255,0:SetFont MediumFont
		Text 320,450,"Remake (C) 2005 Lysozyme",True,False
		Color 255,80,0:SetFont LargeFont
		Text 202,252,"1 - Regular Game":Text 202,302,"2 - Bases Only":Text 202,352,"3 - Instructions"
		Color 255,255,0
		Text 200,250,"1 - Regular Game":Text 200,300,"2 - Bases Only":Text 200,350,"3 - Instructions"

		
		Flip
	Forever
	
	.instructions
	rad=False:lad=False
	Repeat
		If KeyDown(1) Then Goto mainmenu		
		If KeyDown(203) And lad=False And InstructionPage>1 Then
			lad=True:InstructionPage=InstructionPage-1
		EndIf
		If KeyDown(205) And rad=False And InstructionPage<6 Then
			rad=True:InstructionPage=InstructionPage+1
		EndIf
		If Not KeyDown(203) Then lad=False
		If Not KeyDown(205) Then rad=False
		
		WaitTimer(FrameTimer)
		Cls
		UpdateStarField(1)
		DisplayInstructionPage(InstructionPage)
		Flip
		If KeyDown(1) Then Goto mainmenu
	Forever
	
	
	
	
	.done
	ClearAllStars
End Function

Function DisplayInstructionPage(i)
	For a=1 To 11
		instft(a)=instft(a)+1
		If instft(a)>instftm(a) Then
			instft(a)=0
			instf(a)=instf(a)+1
			If instf(a)>instfm(a) Then instf(a)=1
		EndIf
	Next
	
	Color 255,255,255:SetFont SmallFont
	If i=1 Then Text 320,465,"RIGHT ARROW - Next Page    ESC - MAIN MENU",True,False
	If i>1 And i<6 Then Text 320,465,"LEFT ARROW - Prev Page    RIGHT ARROW - Next Page    ESC - MAIN MENU",True,False
	If i=6 Then Text 320,465,"LEFT ARROW - Prev Page    ESC - MAIN MENU",True,False
	;SetFont MediumFont
	
	If i=1 Then
		Text 20,20,"The foul Demons scream Earthward from mute space, intent on conquest. Only your lone Laser Cannon stands between"
		Text 20,35,"them and their prize, the Earth itself!! Steel yourself, strap on your brass balls, and take them on as they pound your"
		Text 20,50,"lunar base. Then blast off and deal with the demonic Space Armada, and, after that, the first of SIX Demon Bases!!"
		Text 20,65,"Should you destroy the base, it's back to the moon to repeat the mission again, with more and tougher Demons."
		Text 20,80,"Destroy all six Demon Bases and save the Earth.........or else!!!!"
		Text 20,110,"This game is a rather spirited remake of the 1982 Intellivision game. (C) Imagic"
		
		DrawImage PlayerGunImage,35,225
		Text 70,160,"YOUR LASER CANNON"
		Text 70,175,"Use the right and left arrow keys to move your cannon."
		Text 70,190,"Press SPACE to fire. In the Moon and Space stages it will fire one regular shot."
		Text 70,205,"In the Demon Base stage, things get interesting. Press and hold the SPACE key to charge up your gun."
		Text 70,220,"When fully charged, release SPACE to fire a SUPER BLAST. It will be the only way your can hope to"
		Text 70,235,"destroy the demon base!"
		Text 20,265,"Press ESC to quit the game anytime."
		Text 20,280,"Press C to activate cheat. You will not lose cannons but your score will be reset to zero. Press again to remove cheat."
		
		Text 20,310,"Demon Attack has six levels, and each consists of three stages: Moon stage, Space stage, and Demon Base."
		Text 20,325,"All enemies in each stage must be eliminated before you advance. Once a level is completed, your Laser Cannon"
		Text 20,340,"blasts off into deep space for the next stage (or returns to the moon in victory!).
	EndIf
	
	If i=2 Then
		Text 320,20,"MOON STAGE",True,False
		Text 20,50,"The Moon is where the fun begins. Each Moon stage consists of four waves of anywhere from 3 To 18 Demons."
		Text 20,65,"All the Demons in a wave must be destroyed before you can move on to the next wave. Demons take more hits to"
		Text 20,80,"destroy in later levels, and there are more of them!"
		Text 320,120,"ENEMIES",True,False
		DrawImage WingedWarriorImage(1),80,160,13+instf(2)
		DrawImage TentacledTerroristImage(1),70,220,instf(3)-1
		DrawImage TentacledTerroristImage(1),96,220,instf(3)-1
		DrawImage LargeAmoebaImage(1),85,290,instf(5)-1
		DrawImage BoundBomberImage(1),80,360,7+instf(8)
		Text 180,145,"WINGED WARRIORS":Text 320,145,"Fly at medium speed. Quite tough To kill at later levels."
		Text 180,205,"TENTACLED TERRORISTS":Text 320,205,"Appear as a bound pair, which may be split by shooting it.":Text 320,220,"Each may then be shot normally. Very agile."
		Text 180,260,"AMOEBAE"
		Text 320,260,"Large amoebae may be split into two medium amoebae."
		Text 320,275,"Medium amoebae may be split into two small amoebae."
		Text 320,290,"The smaller the amoeba, the faster it flies!"
		Text 180,350,"BOUND BOMBERS"
		Text 320,350,"Appear in groups of five, bound together in a chain."
		Text 320,365,"All must be destroyed before the next group appears."
	EndIf

	If i=3 Then
		Text 320,20,"MOON STAGE",True,False
		Text 20,50,"The Demons attacking you on the moon will shower you with lethal bombs.
		DrawImage PelletPulverizerImage,40,100
		DrawImage JaggedJuggernautImage,40,175,0
		DrawImage GuidedDetonatorImage,40,250,0
		Text 100,90,"PELLET PULVERIZERS"
		Text 280,90,"Concentrated bombs which destroy your cannon on contact!"
		
		Text 100,165,"JAGGED JUGGERNAUTS"
		Text 280,165,"These spinning bombs hit with large explosions and will"
		Text 280,180,"destroy your cannon on contact or if it lands near your 
		Text 280,195,"cannon. They appear after the First Demon Base is destroyed."
		Text 100,240,"HEAT DETECTING DETONATORS"
		Text 280,240,"Guided bombs which home in on your cannon!"
		Text 280,255,"Appear After the third Demon Base is destroyed."
		
		Text 20,300,"Wipe out all four waves on the moon and your Laser Cannon blasts off to confront the Demon Space Armada!"
	EndIf
	
	If i=4 Then
		Text 320,20,"SPACE STAGE",True,False
		Text 20,50,"Ahh...nothing like a shameless Galaga rip-off!"
		Text 20,65,"Take on the Space Armada, and blast them to oblivion before confronting the Demon Base! They maintain formation while"
		Text 20,80,"pelting you with fire. Some will break formation and charge after you, destroying your Laser Cannon should you collide"
		Text 20,95,"with them. Their speed and numbers will depend on the current level."
		Text 20,130,"ENEMIES:"
		DrawImage SpaceFrontImage(1),60,180,11+instf(9)
		DrawImage SpaceMiddleImage(1),60,250,7+instf(10)
		DrawImage SpaceRearImage(1),60,320,instf(11)-1
		Text 150,170,"DRAGON":Text 300,170,"First two rows"
		Text 150,240,"MUTANT DRAGONFLY":Text 300,240,"Last two rows"
		Text 150,300,"MUTANT JELLY"
		Text 300,300,"Stay at the rear, and fire on you. Watch out when most of the fleet"
		Text 300,315,"has been destroyed, since they will blanket the screen with their"
		Text 300,330,"fire. They are VERY tough to destroy."
		Text 20,400,"When the Space Armada is destroyed, it's your Laser Cannon rockets off yet again for a mano-a-mano showdown"
		Text 20,415,"with the Demon Base!!"
	EndIf

	If i=5 Then
		Text 320,20,"DEMON BASE STAGE",True,False
		Text 20,50,"This is it! After defeating the lunar Demons and the Space Armada, you take on the Demon Base. Its awesome bulk"
		Text 20,65,"fills space with menace. Your job is (not so) simple: Blast away the defenses and put a Super Charged shot from"
		Text 20,80,"your Laser Cannon into its foul central reactor and blow the base to bits!"
		Text 20,110,"Each base has its own assortment of defenses, be they destructible armor, shields, guns, generators, etc. Plus, each"
		Text 20,125,"base has its own strategy for defeating it, and it's up to you to figure it out!"
		Text 20,155,"Each of the bases DO have one thing in common: Suicide Defenders! Namely the little guys below, who will fly out"
		Text 20,170,"of the bases at various points and head for your cannon, trying to crash into it and destroy it. Shoot them or"
		Text 20,185,"avoid them. They will get faster with each Demon Base you destroy."
		Text 20,215,"Destroy the base and return to the moon in triumph, ready to take on the next wave (or win the game)!!!"
		For a=120 To 520 Step 50:DrawImage SuicideDefenderImage,a,275,7+instf(1):Next
	EndIf	
	
	If i=6 Then
		Text 20,20,"SCORING"
		Text 20,50,"Destroying a Moon or Space Demon"
		Text 20,65,"Splitting a Tentacled Terrorist pair"
		Text 20,80,"Destroying a Suicide Defender"
		Text 20,95,"Destroying a Demon Base"
		Text 250,50,"25 pts"
		Text 250,65,"25 pts"
		Text 250,80,"5 pts"
		Text 250,95,"2000 pts"
		Text 20,125,"You start with 5 Laser Cannons in the regular game and 7 in the Bases Only game."
		Text 20,140,"You control one and the rest are in reserve. Getting blasted obviously costs you one cannon"
		Text 20,155,"from your reserve, and even more obviously, losing your last cannon costs you the Earth."
		Text 20,170,"In the regular game, you get a bonus cannon every 2000 points, and you may have up to 9 cannons in reserve, max."
		Text 20,215,"BASES ONLY OPTION"
		Text 20,245,"Instead of a normal game, you may choose to play only against the six Demon Bases. You'll start in front of the first"
		Text 20,260,"base and fight them one after another. Choose this option in the start menu."
		Text 20,275,"There are NO bonus Laser Cannons in the Bases Only game. The 7 you start with are all you have. Make them count!!!"
		SetFont MediumFont
		Text 320,330,"HAVE FUN!!!",True,False
		SetFont SmallFont
	EndIf
End Function

Function InitializeVariables()
	px=320:py=419:ChargeStage=0:ChargeTimer=0:GameStage=1:GameLevel=0:FireDown=False:ScreenShake=0:HeartBeatTiner=0
	DeathTimer=0:Blink=True:Lives=4:Score=0:NextBonusLife=2000:Cheat=False
	;If BasesOnly=True Then py=479:GameStage=3:NextStageTimer=700:Lives=6
	MoonPos=0
	For a=1 To 3:For b=1 To 5:BoundBomber(a,b)\exist=False:Next:Next
	SuperChargeSoundStage=0
	For a=1 To 11:instf(a)=0:instft(a)=0:Next
End Function

Function UpdateHUD()
	SetFont MediumFont
	If Cheat=False Then
		Color 100,100,100
		Text 12,7,Score:Text 617,7,Lives
		Color 255,255,255
		Text 10,5,Score:Text 615,5,Lives
	Else
		Color 100,100,100
		Text 12,7,"CHEAT":Text 617,7,Lives
		Color 255,255,255
		Text 10,5,"CHEAT":Text 615,5,Lives
	EndIf
End Function

Function DrawMoonScape(pos#)
	DrawImage EarthImage,EarthX,EarthY+pos
	DrawBlock MoonSurfaceImage,0,420+pos
End Function

Function UpdatePlayerGun()
	If px>625 Then px=625
	If px<14 Then px=14
	If ChargeStage>0 Then
		DrawImage PlayerGunGlowsImage,px,py-57,((ChargeStage-1)*3)+Rand(0,2)
	EndIf
	If DeathTimer=0 Then DrawImage PlayerGunImage,px,py
	If DeathTimer>0 Then
		DeathTimer=DeathTimer-1
		If Deathtimer=300 Then PlaySound InsultSound(Rand(1,5))
		If DeathTimer<=150 Then
			If Blink=True Then Blink=False Else Blink=True
			If Blink=True Then DrawImage PlayerGunImage,px,py
		EndIf
	EndIf
End Function

Function RocketThrust()
	For ff=1 To 5 AddDebris(Rand(1,9),Rand(1,3),px+Rand(-15,15),py-3,Rnd(-1,1),Rnd(2,7)):Next
End Function

Function KillPlayer()
	;Return
	AddExplosion(px,py-19,6,7)
	StopChannel SuperChargeChannel:SuperChargeSoundStage=0
	PlaySound ExplosionSound(4)
	AddDebrisExplosion(px,py-19,100,1,7,9)
	DeathTimer=400:ChargeTimer=0:ChargeStage=0:px=320
	If GameStage=1 Then py=419 Else py=479
	If BasesOnly=True Then py=479
End Function

Function NextLevel()
	GameLevel=GameLevel+1;:MoonPos=300:py=419
	EarthX=Rand(30,610):EarthY=Rand(350,410)
	SpaceEnemyPattern=Rand(1,4):SpaceEnemyPos=-300
	Wave=1:DemonsLeft=NumDemons(GameLevel,1)
End Function

Function NextStage(l)
	GameStage=l
	If l<>1 Then NextStageTimer=700 Else NextStageTimer=1300
	ClearEnemyBombsandDebris
End Function

Function DestroyDemonBase()
	AddExplosion(320,ReactorY(GameLevel),9,9)
	PlaySound ExplosionSound(5)
	If GameLevel<6 Then PlaySound BaseDestroyedPutdownSound(Rand(1,5)) Else PlaySound NoooooSound
	For Enemy.EnemyType=Each EnemyType:Delete Enemy:Next
	NextStage(1):NextLevel:ScreenShake=1000
	AddToScore(2000)
End Function

Function HandleMoonWaves()
;waves:  1=winged warriors  2=tentacled terrorists  3=amoebae  4=bound bombers
	For a=1 To 11:EnemyCo(a)=0:Next
	For Enemy.EnemyType=Each EnemyType
		EnemyCo(Enemy\t)=EnemyCo(Enemy\t)+1
	Next
	For a=1 To 3:For b=1 To 5
		If BoundBomber(a,b)\exist=True Then EnemyCo(8)=EnemyCo(8)+1:Exit
	Next:Next
	If Wave=1 Then
		If EnemyCo(2)=0 And DemonsLeft=0 Then 
			Wave=2:DemonsLeft=NumDemons(GameLevel,2)
		Else
			If EnemyCo(2)<MaxEnemiesOnScreen(GameLevel,1) Then
				If DemonsLeft>0 Then AddMoonEnemy(2):DemonsLeft=DemonsLeft-1
			EndIf
		EndIf
	EndIf
	If Wave=2 Then
		If EnemyCo(3)=0 And EnemyCo(4)=0 And DemonsLeft=0 Then 
			Wave=3:DemonsLeft=NumDemons(GameLevel,3)
		Else
			en=2
			If EnemyCo(3)<MaxEnemiesOnScreen(GameLevel,2) And EnemyCo(4)<MaxEnemiesOnScreen(GameLevel,2) Then
				If DemonsLeft>0 Then AddMoonEnemy(3):DemonsLeft=DemonsLeft-1
			EndIf
		EndIf
	EndIf
	If Wave=3 Then
		If EnemyCo(5)=0 And EnemyCo(6)=0 And EnemyCo(7)=0 And DemonsLeft=0 Then 
			Wave=4:DemonsLeft=NumDemons(GameLevel,4)
		Else
			If EnemyCo(5)<MaxEnemiesOnScreen(GameLevel,3) And EnemyCo(6)<=MaxEnemiesOnScreen(GameLevel,3) And EnemyCo(7)<=MaxEnemiesOnScreen(GameLevel,3) Then
				If DemonsLeft>0 Then AddMoonEnemy(5):DemonsLeft=DemonsLeft-1
			EndIf
		EndIf
	EndIf
	If Wave=4
		If EnemyCo(8)=0 And DemonsLeft=0 Then
			NextStage(2)
		Else
			If EnemyCo(8)<MaxEnemiesOnScreen(GameLevel,4) And DemonsLeft>0 Then
				DemonsLeft=DemonsLeft-1
				AddMoonEnemy(8)
			EndIf
		EndIf
	EndIf
End Function

Function SetUpSpaceWaves()
	;Return
	For a=1 To 4:AddEnemy(11,80+(160*(a-1)),40):Next
	For a=1 To 8:For b=1 To 4
		If b=1 Or b=2 Then t=10 Else t=9
		AddEnemy(t,55+(75*(a-1)),100+(50*(b-1)))
	Next:Next
End Function

Function HandleSpaceWaves(pos)
	;Color Rand(0,255),Rand(0,255),Rand(0,255)
	;Rect(100,100,200,200,True)
	Co=0:NumSpaceEnemies=0
	For Enemy.EnemyType=Each EnemyType
		Enemy\cycle=Enemy\cycle+5
		If Enemy\cycle>359 Then Enemy\cycle=Enemy\cycle-360
		NumSpaceEnemies=NumSpaceEnemies+1
		If Enemy\formation=True Then
			If SpaceEnemyPattern=1 Then
				Enemy\x=Enemy\ox+( ((320-Enemy\ox)/10) *Cos(Enemy\cycle))
				Enemy\y=pos+Enemy\oy+( ((320-Abs((320-Enemy\ox)))/10) *Sin(Enemy\cycle+180))
			EndIf
		
			If SpaceEnemyPattern=2 Then
				Enemy\x=Enemy\ox+( ((320-Enemy\ox)/10) *Cos(Enemy\cycle))
				Enemy\y=pos+Enemy\oy+( ((-Abs((320-Enemy\ox)))/10) *Sin(Enemy\cycle+180))
			EndIf

			If SpaceEnemyPattern=3 Then
				Enemy\x=Enemy\ox+( ((320-Enemy\ox)/10) *Sin(Enemy\cycle))
				Enemy\y=pos+Enemy\oy+( ((320-Enemy\ox)/10) *Cos(Enemy\cycle+(320-Enemy\ox)))
			EndIf

			If SpaceEnemyPattern=4 Then
				Enemy\x=Enemy\ox+( ((320-Enemy\ox)/10) *Sin(Enemy\cycle))
				Enemy\y=pos+Enemy\oy+(10*Sin(Enemy\cycle+(320-Enemy\ox)))
			EndIf
		Else
			Co=Co+1
		EndIf
	Next
	If GameLevel=1 Or GameLevel=2 Then ne=2
	If GameLevel=3 Or GameLevel=4 Or GameLevel=5 Then ne=3
	If GameLevel=6 Then ne=4
	If Co<ne And pos=0 Then
		For Enemy.EnemyType=Each EnemyType
			If Rand(1,100)=1 And Enemy\formation=True And Enemy\t<>11 Then Enemy\formation=False:Exit
		Next
	EndIf
	
End Function

Function ClearAllStars()
	For Star.StarType=Each StarType:Delete Star:Next
End Function

Function SetupStars()
	For a=1 To 100:AddStar(Rand(0,639),Rand(0,479)):Next
End Function

Function AddStar(x#,y#)     
	c=0
	For Star.StarType=Each StarType:c=c+1:Next
	If c>100 Then Return
	
	Star.StarType=New StarType
	If Rand(1,10)<9 Then t=Rand(1,2) Else t=Rand(3,5)
	Star\x=x:Star\y=y:Star\t=t:Star\my=0
	For a=1 To 10
		Star\my=Star\my+Rnd(0,0.15)
	Next
End Function

Function UpdateStarField(move)  ;move=-1,0,or 1
	For Star.StarType=Each StarType
		If move<>0 Then Star\y=Star\y+Star\my*move
		DrawImage StarImage(Star\t),Star\x,Star\y
		If Star\y>500 Or Star\y<-20 Then Delete Star	
	Next
	If move>0 Then yy=-5 Else yy=484
	AddStar(Rand(0,639),yy)
End Function

Function AddToScore(s)
	If Cheat=False Then Score=Score+s
	If BasesOnly=True Then Return
	Repeat
		If Score>=NextBonusLife Then
			If Lives<9 Then Lives=Lives+1
			NextBonusLife=NextBonusLife+2000		
		EndIf
	Until NextBonusLife>Score
End Function

Function AddPlayerShot(x,y,t)
	PlayerShot.PlayerShotType=New PlayerShotType
	PlayerShot\x=x:PlayerShot\y=y
	PlayerShot\t=t
End Function

Function UpdatePlayerShots()
	For PlayerShot.PlayerShotType=Each PlayerShotType
		If PlayerShot\t=0 Or PlayerShot\t=1 Then et=1:exst=1
		If PlayerShot\t=2 Or PlayerShot\t=3 Then et=5:exst=3
		If PlayerShot\t=4 Then et=6:exst=4
		PlayerShot\y=PlayerShot\y-10
		DrawImage PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t

		;Any Enemies Hit?
		For Enemy.EnemyType=Each EnemyType
			If Enemy\t=1 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,SuicideDefenderImage,Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=2 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,WingedWarriorImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=3 Then 
				coll1=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,TentacledTerroristImage(GameLevel),Enemy\x-13,Enemy\y,Enemy\fdraw)
				coll2=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,TentacledTerroristImage(GameLevel),Enemy\x+13,Enemy\y,Enemy\fdraw)
				If coll1=True Or coll2=True Then coll=True Else coll=False
			EndIf
			If Enemy\t=4 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,TentacledTerroristImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=5 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,LargeAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=6 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,MediumAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=7 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,SmallAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=9 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,SpaceFrontImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=10 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,SpaceMiddleImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
			If Enemy\t=11 Then coll=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,SpaceRearImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw)
		
			If coll=True Then
				enemy\hp=Enemy\hp-1
				AddExplosion(PlayerShot\x,PlayerShot\y,et,4)
			      ;Colors: 1=yellow,2=orange,3=red,4=dark grey,5=med grey,6=light grey,7=green
				
				If Enemy\hp>0 Then PlaySound ExplosionSound(2)
				If Enemy\hp<=0 Then
					If Enemy\t=1 Then AddToScore(5) Else AddToScore(25) 
					If Enemy\t=1 Then des=10:ex=5:exft=5:col=1:fo=3:sp=6
					If Enemy\t=2 Then des=20:ex=2:exft=8:col=2:fo=5:sp=6
					If Enemy\t=3 Then des=10:ex=8:exft=3:col=7:fo=5:sp=6
					If Enemy\t=4 Then des=15:ex=5:exft=5:col=7:fo=5:sp=6
					If Enemy\t=5 Then des=50:ex=2:exft=10:col=7:fo=7:sp=9
					If Enemy\t=6 Then des=30:ex=5:exft=7:col=7:fo=6:sp=9
					If Enemy\t=7 Then des=15:ex=7:exft=4:col=7:fo=5:sp=6
					If Enemy\t=9 Then des=15:ex=5:exft=5:col=3:fo=5:sp=6
					If Enemy\t=10 Then des=15:ex=5:exft=5:col=1:fo=5:sp=6
					If Enemy\t=11 Then des=50:ex=6:exft=5:col=6:fo=5:sp=9
					
					AddExplosion(Enemy\x,Enemy\y,ex,exft):AddDebrisExplosion(Enemy\x,Enemy\y,des,DebrisColor(GameLevel,Enemy\t),fo,sp)
					If Enemy\t=3 Then AddEnemy(4,Enemy\x-13,Enemy\y):AddEnemy(4,Enemy\x+13,Enemy\y)
					If Enemy\t=5 Then For am=1 To 2:AddEnemy(6,Enemy\x,Enemy\y):Next
					If Enemy\t=6 Then For am=1 To 2:AddEnemy(7,Enemy\x,Enemy\y):Next
					
					If Enemy\t=1 Or Enemy\t=3 Then PlaySound ExplosionSound(2) 
					If Enemy\t=5 Or Enemy\t=6 Then PlaySound SquishSound
					If Enemy\t=2 Or Enemy\t=4 Or Enemy\t=7 Or Enemy\t=9 Or Enemy\t=10 Then PlaySound ExplosionSound(3)
					If Enemy\t=11 Then PlaySound ExplosionSound(4)
					
					Delete Enemy
				EndIf
				If PlayerShot\t<>4 Then Delete PlayerShot:Goto done1
			EndIf
		Next
		;Hit Bound Bombers?
		For a=1 To 3
			For b=1 To 5
				If BoundBomber(a,b)\exist=True Then 
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,BoundBomberImage(GameLevel),BoundBomber(a,b)\x,BoundBomber(a,b)\y,BoundBomber(a,b)\fdraw) Then
						BoundBomber(a,b)\hp=BoundBomber(a,b)\hp-1
						AddExplosion(PlayerShot\x,PlayerShot\y,1,4)
						If BoundBomber(a,b)\hp>0 Then PlaySound ExplosionSound(2)
						If BoundBomber(a,b)\hp<=0 Then
							AddToScore(25)
							AddDebrisExplosion(BoundBomber(a,b)\x,BoundBomber(a,b)\y,20,DebrisColor(GameLevel,8),5,9)
							AddExplosion(BoundBomber(a,b)\x,BoundBomber(a,b)\y,2,7)
							BoundBomber(a,b)\exist=False
							PlaySound ExplosionSound(3)
							If (b-1)>=1 Then BoundBomber(a,b-1)\link=False
						EndIf
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
			
			
			
			Next	
		Next

		;DEMON BASES
		If (GameStage=3 And NextStageTimer=0) Or BasesOnly=True Then
			If GameLevel=1 Then
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B1HeadImage,92,6,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B1LeftEndImage,23,137,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B1RightEndImage,525,137,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				
				;Reactor hit?
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B1MouthInteriorImage,227,92,0) Then 
					If PlayerShot\t=4 Then DestroyDemonBase
					AddExplosion(PlayerShot\x,PlayerShot\y,et,4):Delete PlayerShot
					Goto done1
				EndIf
				
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B1ArmorImage,121,189,0) Then
					AddExplosion(PlayerShot\x,PlayerShot\y+14,et,4)
					PlaySound ExplosionSound(exst)
					AddDebrisExplosion(PlayerShot\x,PlayerShot\y+14,10+PlayerShot\t*20,1,3,3)
					SetBuffer ImageBuffer(B1ArmorImage)
					Color 0,0,0
					s=8+PlayerShot\t*5
					For a=1 To 5
						Oval((PlayerShot\x-s)-121+Rand(-5,5),((PlayerShot\y+14)-s)-189+Rand(-10,10),s*2,s*2,True)
					Next
					SetBuffer BackBuffer()
					Delete PlayerShot:Goto done1
				EndIf
				If PlayerShot\x>=119 And PlayerShot\x<=524 And PlayerShot\y>=137 And PlayerShot\y<=188 Then
					b=-405+B1RotWindPos-(PlayerShot\x-119)
					;If b>0 Then b=b-405
					If b<-405 Then b=b+405
						
					;DrawImage B1RotatingWindowImage,b,57
					If ImagesCollide(testpixel,0,PlayerShot\y,0,B1RotatingWindowImage,b,137,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4)
						PlaySound ExplosionSound(exst)
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
			EndIf  ;end gamelevel=1
			
			If GameLevel=2 Then
				;REACTOR HIT?
				If PlayerShot\x>=290 And PlayerShot\x<=350 And PlayerShot\y>=140 And PlayerShot\y<=162 And PlayerShot\t=4 Then DestroyDemonBase:Delete PlayerShot:Goto done1
				
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B2CityAndHornsImage,151,6,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B2RightHornImage,488,159,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B2LeftHornImage,23,159,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				
				If PlayerShot\x>=151 And PlayerShot\x<=487 And PlayerShot\y>=177-10 And PlayerShot\y<=262 Then
					b=-336+B2RotShieldPos-(PlayerShot\x-151)
					;If b>0 Then b=b-405
					If b<-336 Then b=b+336
						
					;DrawImage B2RotatingShieldImage,b,57
					If ImagesCollide(PlayerShotImage,0,PlayerShot\y,PlayerShot\t,B2RotatingShieldImage,b,177,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y+14,et,4)
						PlaySound ExplosionSound(exst)
						SetBuffer ImageBuffer(B2RotatingShieldImage)
						
						c=(PlayerShot\x-151)-B2RotShieldPos
						;If c>405 Then c=c-405
						If c<0 Then c=c+336
						Color 0,0,0:s=8+PlayerShot\t*5;:s=s/2
						For a=1 To 5
							Oval (c-s)+Rand(-5,5),(85-(262-(PlayerShot\y+12))-s)+Rand(-5,5),s*2,s*2,True
						Next
						SetBuffer BackBuffer()
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
			EndIf ;end gamelevel=2
			
			If GameLevel=3 Then
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B3RightEndImage,487,179,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B3LeftEndImage,85,179,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				
				For a=1 To 2
					If a=1 Then xxx=B3LeftGunImage Else xxx=B3RightGunImage
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,xxx,B3GunX(a),183,0) And B3GunExist(a)=True Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4)
						PlaySound ExplosionSound(exst)
						If PlayerShot\t=4 Then 
							B3GunExist(a)=False
							B3GunsTimer(a)=1000
							ScreenShake=50
						EndIf
						Delete PlayerShot:Goto done1
					EndIf
				Next
				
				;RotatingShield
				If PlayerShot\x>=115 And PlayerShot\x<=486 And PlayerShot\y>=193-10 And PlayerShot\y<=264 Then
					b=-332+B3RotShieldPos-(PlayerShot\x-155)
					;If b>0 Then b=b-405
					If b<-331 Then b=b+331
					;DrawImage B1RotatingWindowImage,b,57
					If ImagesCollide(PlayerShotImage,0,PlayerShot\y,PlayerShot\t,B3RotatingShieldImage,b,193,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						SetBuffer ImageBuffer(B3RotatingShieldImage)
						
						c=(PlayerShot\x-155)-B3RotShieldPos
						;If c>405 Then c=c-405
						If c<0 Then c=c+331
						Color 0,0,0:s=8+PlayerShot\t*5
						For a=1 To 5
							Oval (c-s)+Rand(-5,5),(71-(265-(PlayerShot\y+12))-s)+Rand(-5,5),s*2,s*2,True
						Next
						SetBuffer BackBuffer()
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
				
				;RotatingWindow
				If PlayerShot\x>=115 And PlayerShot\x<=486 And PlayerShot\y>=179 And PlayerShot\y<=192 Then
					b=-332+B3RotWindPos-(PlayerShot\x-155)
					;If b>0 Then b=b-405
					If b<-331 Then b=b+331
					If ImagesCollide(testpixel,0,PlayerShot\y,0,B3RotatingWindowImage,b,179,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
				
				;Reactor
				If PlayerShot\x>=290 And PlayerShot\x<=350 And PlayerShot\y>=160 And PlayerShot\y<=180 And PlayerShot\t=4 Then DestroyDemonBase:Delete PlayerShot:Goto done1
				
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B3HeadImage,84,3,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
			EndIf  ;end gamelevel=3
			
			If GameLevel=4 Then
				;Heart
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B4HeartImage,258+(100*Sin(B4heartCycle)),82,B4HeartFrame) 
					If PlayerShot\t=4 Then DestroyDemonBase Else PlaySound ExplosionSound(exst)
					Delete PlayerShot:Goto done1
				EndIf			


				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B4CityAndHornsImage,53,9,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				
				;Armor
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B4ArmorImage,89,239,0) Then
					AddExplosion(PlayerShot\x,PlayerShot\y+14,et,4):PlaySound ExplosionSound(exst)
					AddDebrisExplosion(PlayerShot\x,PlayerShot\y+14,10+PlayerShot\t*20,3,3,3)
					SetBuffer ImageBuffer(B4ArmorImage)
					Color 0,0,0
					s=8+PlayerShot\t*5
					For a=1 To 5
						Oval((PlayerShot\x-s)-89+Rand(-5,5),((PlayerShot\y+14)-s)-239+Rand(-10,10),s*2,s*2,True)
					Next
					SetBuffer BackBuffer()
					Delete PlayerShot:Goto done1
				EndIf

				;Shield pieces
				For a=1 To 50
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B4ShieldPiecesImage,B4ShieldX(a),B4ShieldY(a),B4ShieldType(a)-1) And B4ShieldTimer(a)=0 Then
						AddExplosion(PlayerShot\x,PlayerShot\y+14,et,4)
						AddExplosion(B4ShieldX(a),B4ShieldY(a),2,6):PlaySound ExplosionSound(exst)
						B4ShieldTimer(a)=800
						Delete PlayerShot:Goto done1
					EndIf
				Next
			EndIf ;end gamelevel=4
		
			If GameLevel=5 Then
				
				;Reactor
						;Rect 260,120,120,23,False
				If PlayerShot\x>=260 And PlayerShot\x<=380 And PlayerShot\y>=110 And PlayerShot\y<=132 And PlayerShot\t=4 Then DestroyDemonBase:Delete PlayerShot:Goto done1
				
			
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5HeadImage,110,7,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5LeftSideImage,85,141,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5RightSideImage,515,141,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1

				
				;Generator defenders
				For a=1 To 2:For b=1 To 16
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5GeneratorDefenderImage,B5ProtectorX(a,b),B5ProtectorY(a,b),0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						Delete PlayerShot:Goto done1
					EndIf
				Next:Next
				;Extra Shield
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5ExtraShieldImage,118,227,0) And (B5GeneratorExist(1)=True Or B5GeneratorExist(2)=True) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				;Generators
				For a=1 To 2
					If a=2 Then x=554 Else x=29
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B5RotatingGeneratorImage,x,108,B5GeneratorFrame) And B5GeneratorExist(a)=True Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						If PlayerShot\t=4 Then
							AddGreyDebrisExplosion(x,128,200,4,9)
							B5GeneratorExist(a)=False
							ScreenShake=100
						EndIf
						Delete PlayerShot:Goto done1
					EndIf
				Next
				;RotatingShield
				If PlayerShot\x>=124 And PlayerShot\x<=514 And PlayerShot\y>=171-10 And PlayerShot\y<=218 Then
					b=-391+B5RotShieldPos-(PlayerShot\x-124)
					;If b>0 Then b=b-405
					If b<-390 Then b=b+390
					If ImagesCollide(PlayerShotImage,0,PlayerShot\y,PlayerShot\t,B5RotatingShieldImage,b,171,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						SetBuffer ImageBuffer(B5RotatingShieldImage)
						
						c=(PlayerShot\x-124)-B5RotShieldPos
						;If c>405 Then c=c-405
						If c<0 Then c=c+390
						Color 0,0,0:s=8+PlayerShot\t*5
						For a=1 To 5
							Oval (c-s)+Rand(-5,5),(46-(218-(PlayerShot\y+12))-s)+Rand(-5,5),s*2,s*2,True
						Next
						SetBuffer BackBuffer()
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
				
				;RotatingWindow
				If PlayerShot\x>=124 And PlayerShot\x<=514 And PlayerShot\y>=141 And PlayerShot\y<=171 Then
					b=-391+B5RotWindPos-(PlayerShot\x-124)
					;If b>0 Then b=b-405
					If b<-390 Then b=b+390
					If ImagesCollide(testpixel,0,PlayerShot\y,0,B5RotatingWindowImage,b,141,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
			EndIf ;end gamelevel=5
			
			If GameLevel=6 Then
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6HeadAndHornsImage,8,3,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6LeftEndImage,145,171,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6RightEndImage,468,171,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				If (GenExist(1)=True Or GenExist(2)=True) Then 
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6ReactorGuardImage,279,165,0) Then AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst):Delete PlayerShot:Goto done1
				EndIf
				For a=1 To 2:For b=1 To 2
					aa=False
					If a=1 Then aa=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6LeftGunImage,GunsX(a,b),GunsY(a,b),0)
					If a=2 Then aa=ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6RightGunImage,GunsX(a,b),GunsY(a,b),0)
					If aa=True And GunsExist(a,b)=True
						;AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						AddExplosion(PlayerShot\x,PlayerShot\y,6,4):PlaySound ExplosionSound(4)
						;If PlayerShot\t=4 Then ScreenShake=50:GunsExist(a,b)=False:AddDebrisExplosion(GunsX(a,b)+13,GunsY(a,b)+13,50,3,3,6)
						ScreenShake=50:GunsExist(a,b)=False:AddDebrisExplosion(GunsX(a,b)+13,GunsY(a,b)+13,50,3,3,6)
						Delete PlayerShot:Goto done1
					EndIf
				Next:Next
				;Generators
				For a=1 To 2
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6GlowingGeneratorImage,GenX(a),141,0) Then 
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						If PlayerShot\t=4 Then 
							ScreenShake=200:GenExist(a)=False
							;Function AddDebrisExplosion(x#,y#,n,c,force#,sizeparts)
							AddDebrisExplosion(GenX(a)+13,154,150,2,3,9)
						EndIf	

						Delete PlayerShot:Goto done1
					EndIf
				Next

				;Shield pieces
				For a=1 To 50
					If ImagesCollide(PlayerShotImage,PlayerShot\x,PlayerShot\y,PlayerShot\t,B6ShieldPiecesImage,B6ShieldX(a),B6ShieldY(a),B6ShieldType(a)-1) And B6ShieldTimer(a)=0 Then
						AddExplosion(PlayerShot\x,PlayerShot\y+14,et,4):PlaySound ExplosionSound(exst)
						B6ShieldTimer(a)=1000:AddExplosion(B6ShieldX(a),B6ShieldY(a),2,6)
						Delete PlayerShot:Goto done1
					EndIf
				Next

				;RotatingWindow
				If PlayerShot\x>=171 And PlayerShot\x<=467 And PlayerShot\y>=170 And PlayerShot\y<=210 Then
					b=-297+B6RotWindPos-(PlayerShot\x-171)
					;If b>0 Then b=b-405
					If b<-296 Then b=b+296
					If ImagesCollide(testpixel,0,PlayerShot\y,0,B6RotatingWindowImage,b,170,0) Then
						AddExplosion(PlayerShot\x,PlayerShot\y,et,4):PlaySound ExplosionSound(exst)
						Delete PlayerShot:Goto done1
					EndIf
				EndIf
				
				;REACTOR HIT?
				If PlayerShot\x>=290 And PlayerShot\x<=350 And PlayerShot\y>=140 And PlayerShot\y<=170 And PlayerShot\t=4 And (GenExist(1)=False And GenExist(2)=False) Then
					DestroyDemonBase:Delete PlayerShot:Goto done1
				EndIf
			EndIf ;end gamelevel=6
		
		EndIf
		 
		If PlayerShot\y<-10 Then Delete PlayerShot
		.done1
	Next
End Function

Function AddDebrisExplosion(x#,y#,n,c,force#,sizeparts)
	For a=1 To n
		an#=Rand(0,360):f#=Rnd(0,force)
		mx#=f*Sin(an):my#=f*-Cos(an)
		AddDebris(Rand(1,sizeparts),c,x,y,mx,my)
	Next
End Function

Function AddGreyDebrisExplosion(x#,y#,n,force#,sizeparts)
	For a=1 To n
		an#=Rand(0,360):f#=Rnd(0,force)
		mx#=f*Sin(an):my#=f*-Cos(an)
		AddDebris(Rand(1,sizeparts),Rand(4,6),x,y,mx,my)
	Next
End Function

Function AddDebris(t,c,x#,y#,mx#,my#)
	Debris.DebrisType=New DebrisType
	Debris\x=x:Debris\y=y:Debris\f=0:Debris\ft=0
	Debris\t=t:Debris\c=c
	Debris\mx=mx:Debris\my=my
	If GameStage=2 Then Debris\g=False Else Debris\g=True
End Function

Function UpdateDebris()
	For Debris.DebrisType=Each DebrisType
		Debris\x=Debris\x+Debris\mx
		Debris\y=Debris\y+Debris\my
		Debris\my=Debris\my+0.05
		Debris\ft=Debris\ft+1
		If Debris\ft>=6 Then
			Debris\ft=0
			Debris\f=Debris\f+1
			If Debris\f>2 Then Debris\f=0
		EndIf
		DrawImage DebrisImage,Debris\x,Debris\y,((Debris\c-1)*27)+(Debris\t-1)+(Debris\f*9)
		If Debris\x>650 Or Debris\x<-10 Then Delete Debris:Goto donedeb
		If Debris\y>490 Or Debris\y<-10 Then Delete Debris
		.donedeb
	Next
End Function

Function AddTickerTape(x#,y#,mx#,my#,t)
	TickerTape.TickerTapeType=New TickerTapeType
	TickerTape\x=x:TickerTape\y=y
	TickerTape\mx=mx:TickerTape\my=my
	TickerTape\f=Rand(1,6):TickerTape\ft=0
	TickerTape\d=1:TickerTape\t=t
End Function

Function UpdateTickerTape()
	For TickerTape.TickerTapeType=Each TickerTapeType
		TickerTape\x=TickerTape\x+TickerTape\mx
		TickerTape\y=TickerTape\y+TickerTape\my
		TickerTape\ft=TickerTape\ft+1
		If TickerTape\ft>6 Then
			TickerTape\ft=0
			TickerTape\f=TickerTape\f+TickerTape\d
			If TickerTape\d=1 And TickerTape\f>6 Then TickerTape\f=5:TickerTape\d=-1
			If TickerTape\d=-1 And TickerTape\f<1 Then TickerTape\f=2:TickerTape\d=1
		EndIf
		DrawImage TickerTapeImage(TickerTape\t),TickerTape\x,TickerTape\y,TickerTape\f-1
		If TickerTape\x>700 Or TickerTape\x<-60 Then Delete TickerTape:Goto done
		If TickerTape\y>540 Or TickerTape\y<-60 Then Delete TickerTape
		.done
	Next
End Function

Function AddExplosion(x,y,t,ftm)
	Explo.ExploType=New ExploType
	Explo\x=x:Explo\y=y:Explo\t=t:Explo\ftm=ftm
	Explo\f=0:Explo\ft=0
End Function

Function UpdateExplosions()
	For Explo.ExploType=Each ExploType
		If Explo\t<>0 Then DrawImage ExploImage(Explo\t),Explo\x,Explo\y,Explo\f
		;Color 255,255,255
		;Text Explo\x,Explo\y+30,Explo\f
		Explo\ft=Explo\ft+1
		If Explo\ft=>Explo\ftm Then
			Explo\ft=0
			Explo\f=Explo\f+1
			If Explo\f>=ExploFrames(Explo\t) Then Delete Explo
		EndIf
	Next
End Function

Function ClearEnemyBombsandDebris()
	For SpaceBomb.SpaceBombType=Each SpaceBombType:Delete SpaceBomb:Next
	For MoonBomb.MoonBombType=Each MoonBombType:Delete MoonBomb:Next
	For Debris.DebrisType=Each DebrisType:Delete Debris:Next
End Function

Function AddSpaceBomb(x#,y#,mx#,my#,t)  ;t=1 space bomb  t=2 base bomb
	If DeathTimer>0 Then Return
	SpaceBomb.SpaceBombType=New SpaceBombType
	SpaceBomb\x=x:SpaceBomb\y=y:SpaceBomb\mx=mx:SpaceBomb\my=my
	SpaceBomb\t=t:SpaceBomb\f=0:SpaceBomb\ft=0
	PlaySound EnemyFireSound
End Function

Function UpdateSpaceBombs()
	For SpaceBomb.SpaceBombType=Each SpaceBombType
		SpaceBomb\x=SpaceBomb\x+SpaceBomb\mx
		SpaceBomb\y=SpaceBomb\y+SpaceBomb\my
		f=1:ft=10
		If SpaceBomb\t=2 Then f=2:ft=6
		SpaceBomb\ft=SpaceBomb\ft+1
		If SpaceBomb\ft>ft Then
			SpaceBomb\ft=0
			SpaceBomb\f=SpaceBomb\f+1
			If SpaceBomb\f>f Then SpaceBomb\f=0
		EndIf
		If SpaceBomb\t=1 Then xxx=SpaceBombImage
		If SpaceBomb\t=2 Then xxx=BaseBombImage

		DrawImage xxx,SpaceBomb\x,SpaceBomb\y,SpaceBomb\f

		If SpaceBomb\x>650 Or SpaceBomb\x<-10 Then Delete SpaceBomb:Goto donespacebomb
		If SpaceBomb\y>490 Or SpaceBomb\y<-10 Then Delete SpaceBomb:Goto donespacebomb
		
		If GameStage=1 And SpaceBomb\y>420 And BasesOnly=False Then
			AddExplosion(SpaceBomb\x,420,1,6)
			Delete SpaceBomb:Goto donespacebomb
		EndIf

		If SpaceBomb\y>400 Then
			If ImagesCollide(xxx,SpaceBomb\x,SpaceBomb\y,SpaceBomb\f,PlayerGunImage,px,py,0) And DeathTimer=0 Then
				If DeathTimer=0 Then KillPlayer
				Delete SpaceBomb:Goto donespacebomb
			EndIf
		EndIf
		
		.donespacebomb
	Next
End Function

Function AddMoonBomb(x#,y#,my#,t)
	co=0
	For MoonBomb.MoonBombType=Each MoonBombType:co=co+1:Next
	If co>=10 Then Return
	MoonBomb.MoonBombType=New MoonBombType
	MoonBomb\x=x:MoonBomb\y=y:MoonBomb\t=t
	
	If my>3 Then my=my*0.75
	
	MoonBomb\my=my
	MoonBomb\f=1:MoonBomb\ft=0
End Function

Function UpdateMoonBombs()
	For MoonBomb.MoonBombType=Each MoonBombType
		If MoonBomb\t=1 Then f=1:ft=0:xxx=PelletPulverizerImage:ex=8:eftm=8
		If MoonBomb\t=2 Then f=6:ft=3:xxx=JaggedJuggernautImage:ex=10:eftm=8
		If MoonBomb\t=3 Then 
			f=2:ft=20:xxx=GuidedDetonatorImage:ex=11:eftm=6
			If MoonBomb\x>px+8 Then MoonBomb\mx=MoonBomb\mx-0.05
			If MoonBomb\x<px-8 Then MoonBomb\mx=MoonBomb\mx+0.05
			If MoonBomb\x>=px-8 And MoonBomb\x<=px+8 Then MoonBomb\mx=MoonBomb\mx*0.95
		EndIf
		If MoonBomb\mx>2 Then MoonBomb\mx=2
		If MoonBomb\mx<-2 Then MoonBomb\mx=-2
		MoonBomb\x=MoonBomb\x+MoonBomb\mx
		MoonBomb\y=MoonBomb\y+MoonBomb\my
		MoonBomb\ft=MoonBomb\ft+1
		If MoonBomb\ft>ft Then 
			MoonBomb\ft=0:MoonBomb\f=MoonBomb\f+1
			If MoonBomb\f>f Then MoonBomb\f=1
			If MoonBomb\t=3 And MoonBomb\f=1 Then PlaySound BeepSound
		EndIf
		DrawImage xxx,MoonBomb\x,MoonBomb\y,MoonBomb\f-1
		If MoonBomb\y>479 Then Delete MoonBomb:Goto done2
		If ImagesCollide(xxx,MoonBomb\x,MoonBomb\y,MoonBomb\f-1,MoonSurfaceImage,0,420,0) Then
			AddExplosion(MoonBomb\x,419,ex,eftm)
			If MoonBomb\t=1 Then PlaySound ExplosionSound(1)
			If MoonBomb\t=2 Then PlaySound ExplosionSound(4)
			If MoonBomb\t=3 Then PlaySound ExplosionSound(3)
			If MoonBomb\t=2 And Abs(px-MoonBomb\x)<=50 And DeathTimer=0 Then KillPlayer
			Delete MoonBomb:Goto done2
		EndIf
		If MoonBomb\y>350 Then
			If ImagesCollide(xxx,MoonBomb\x,MoonBomb\y,MoonBomb\f-1,PlayerGunImage,px,py,0) And DeathTimer=0 Then
				If DeathTimer=0 Then KillPlayer
				Delete MoonBomb:Goto done2
			EndIf
		EndIf
		.done2
	Next
End Function

Function AddMoonEnemy(t)
	w=Rand(1,3)
	If t<>8 Then
		If w=1 Then x=Rand(0,639):y=-120
		If w=2 Then x=-120:y=Rand(0,300)
		If w=3 Then x=759:y=Rand(0,300)
	Else
		If w=1 Then x=Rand(0,360):y=-120
		If w=2 Then x=-400:y=Rand(0,300)
		If w=3 Then x=759:y=Rand(0,300)
	EndIf
	AddEnemy(t,x,y)
End Function

Function AddEnemy(t,x#,y#)  
;1=suicide defender
;2=winged warrior
;3=bound tentacled terrorists
;4=individual tentacled terrorist
;5=large amoeba
;6=medium amoeba
;7=small amoeba
;8=Bound bomber
;9=space front (dragon)
;10=space middle (dragonfly)
;11=space rear (

;Type BoundBomberType
;	Field x#,y#,mx#,my#,hp,f,ft,fdraw,mxtimer,mytimer
;	Field id,b1,b2,exist
;End Type
	If t=8 Then
		For a=1 To 3
			If BoundBomber(a,1)\exist=False And BoundBomber(a,2)\exist=False And BoundBomber(a,3)\exist=False And BoundBomber(a,4)\exist=False And BoundBomber(a,5)\exist=False Then
				For b=1 To 5
					BoundBomber(a,b)\exist=True
					BoundBomber(a,b)\x=x+((b-1)*80):BoundBomber(a,b)\y=y
					BoundBomber(a,b)\mx=Rnd(-2,2):BoundBomber(a,b)\my=Rnd(-2,2)
					BoundBomber(a,b)\hp=Rand(DemonHP(GameLevel,8,1),DemonHP(GameLevel,8,2))
					BoundBomber(a,b)\f=1:BoundBomber(a,b)\ft=0
					BoundBomber(a,b)\mxtimer=0:BoundBomber(a,b)\mytimer=0
					If b<5 Then BoundBomber(a,b)\link=True Else BoundBomber(a,b)\link=False
					BoundBomber(a,b)\fdraw=0
					
					;BoundBomber(a,b)\hp=1
					
				Next
				Return
			EndIf
		Next
	EndIf
	Enemy.EnemyType=New EnemyType
	Enemy\t=t:Enemy\x=x:Enemy\y=y
	Enemy\mx=0:Enemy\my=0
	If t=1 Then Enemy\hp=1 Else Enemy\hp=Rand(DemonHP(GameLevel,t,1),DemonHP(GameLevel,t,2))
	
	;Enemy\hp=1
	
	If t>=9 And t<=11 Then 
		Enemy\x2=x:Enemy\y2=y:Enemy\formation=True
		Enemy\ox=x:Enemy\oy=y:Enemy\cycle=0
	EndIf
	f=1:ft=0
	If t=9 Then f=Rand(1,6):ft=Rand(0,5)
	If t=10 Then f=Rand(1,4):ft=Rand(0,2)
	If t=11 Then f=Rand(1,4):ft=Rand(0,4)
	Enemy\f=f:Enemy\ft=ft
	Enemy\mxtimer=0:Enemy\mytimer=0:Enemy\fdraw=0:Enemy\shooting=0
	If t=2 Then Enemy\my=Rnd(-2,2)
	If t>=3 And t<=7 Then 
		Enemy\mx=Rnd(3,5):Enemy\my=Rnd(3,4)
		If Rand(1,2)=1 Then Enemy\mx=Enemy\mx*-1
		If Rand(1,2)=1 Then Enemy\my=Enemy\my*-1
	EndIf
End Function


Function UpdateEnemies()
	;Bound Bombers
	For a=1 To 3
		For b=1 To 5:BoundBomber(a,b)\manip=False:Next
		For b=1 To 5
			If BoundBomber(a,b)\exist=True Then
				Bank=3
				If BoundBomber(a,b)\mx>=1 Then bank=2
				If BoundBomber(a,b)\mx>2 Then bank=1
				If BoundBomber(a,b)\mx<=-1 Then bank=4
				If BoundBomber(a,b)\mx<=-2 Then bank=5
				BoundBomber(a,b)\x=BoundBomber(a,b)\x+BoundBomber(a,b)\mx
				BoundBomber(a,b)\y=BoundBomber(a,b)\y+BoundBomber(a,b)\my
				
				BoundBomber(a,b)\ft=BoundBomber(a,b)\ft+1
				If BoundBomber(a,b)\ft>2 Then
					BoundBomber(a,b)\ft=0:BoundBomber(a,b)\f=BoundBomber(a,b)\f+1
					If BoundBomber(a,b)\f>4 Then BoundBomber(a,b)\f=1
				EndIf
				
				If BoundBomber(a,b)\manip=False Then
					If BoundBomber(a,b)\mxtimer=0 Then
						If BoundBomber(a,b)\x>px Then BoundBomber(a,b)\mx=BoundBomber(a,b)\mx-0.075
						If BoundBomber(a,b)\x<px Then BoundBomber(a,b)\mx=BoundBomber(a,b)\mx+0.075
					EndIf
					If Rand(1,50)=1 Then
						If Rand(1,2)=1 Then BoundBomber(a,b)\mytimer=Rand(5,15) Else BoundBomber(a,b)\mytimer=Rand(-15,-5)
					EndIf
					If Rand(1,100)=1 Then
						If Rand(1,2)=1 Then BoundBomber(a,b)\mxtimer=Rand(3,8) Else BoundBomber(a,b)\mxtimer=Rand(-8,-3)
					EndIf
					If BoundBomber(a,b)\y>290 Then BoundBomber(a,b)\mytimer=-10
					If BoundBomber(a,b)\y<60 Then BoundBomber(a,b)\mytimer=10
					If BoundBomber(a,b)\mx>5 Then BoundBomber(a,b)\mx=5
					If BoundBomber(a,b)\mx<-5 Then BoundBomber(a,b)\mx=-5
					If BoundBomber(a,b)\my>4 Then BoundBomber(a,b)\my=4
					If BoundBomber(a,b)\my<-4 Then BoundBomber(a,b)\my=-4
					If BoundBomber(a,b)\mytimer>0 Then 
						BoundBomber(a,b)\mytimer=BoundBomber(a,b)\mytimer-1
						BoundBomber(a,b)\my=BoundBomber(a,b)\my+0.1
					EndIf
					If BoundBomber(a,b)\mytimer<0 Then 
						BoundBomber(a,b)\mytimer=BoundBomber(a,b)\mytimer+1
						BoundBomber(a,b)\my=BoundBomber(a,b)\my-0.1
					EndIf
					If BoundBomber(a,b)\mxtimer>0 Then 
						BoundBomber(a,b)\mxtimer=BoundBomber(a,b)\mxtimer-1
						BoundBomber(a,b)\mx=BoundBomber(a,b)\mx+0.1
					EndIf
					If BoundBomber(a,b)\mxtimer<0 Then 
						BoundBomber(a,b)\mxtimer=BoundBomber(a,b)\mxtimer+1
						BoundBomber(a,b)\mx=BoundBomber(a,b)\mx-0.1
					EndIf
				EndIf
				
				links=0
				For c=b To 4
					If BoundBomber(a,c)\link=True Then
						links=links+1
						BoundBomber(a,c+1)\mx=BoundBomber(a,b)\mx
						BoundBomber(a,c+1)\my=BoundBomber(a,b)\my
						BoundBomber(a,c)\manip=True
					Else
						Exit
					EndIf
				Next
				If BoundBomber(a,b)\x>580-(80*Links) Then BoundBomber(a,b)\mxtimer=-10
	
				
				BoundBomber(a,b)\fdraw=((Bank-1)*4)+(BoundBomber(a,b)\f-1)
				DrawImage BoundBomberImage(GameLevel),BoundBomber(a,b)\x,BoundBomber(a,b)\y,BoundBomber(a,b)\fdraw
				
				If GameLevel=1 Then t=1
				If GameLevel>=2 Then
					If Rand(1,8)=1 Then t=2 Else t=1	
				EndIf
				If GameLevel>=4 Then
					z=Rand(1,25)
					t=1
					If z=1 Then t=3
					If z=2 Or z=3 Or z=4 Then t=2
				EndIf
				If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(BoundBomber(a,b)\x,BoundBomber(a,b)\y,(Rnd(2,2+GameLevel)/t),t)
			EndIf
		Next
	Next
	
	If GameLevel=1 Then t=1
	If GameLevel>=2 Then
		If Rand(1,8)=1 Then t=2 Else t=1	
	EndIf
	If GameLevel>=4 Then
		z=Rand(1,25)
		t=1
		If z=1 Then t=3
		If z=2 Or z=3 Or z=4 Then t=2
	EndIf

	For Enemy.EnemyType=Each EnemyType
		bank=3
		If Enemy\mx>=1 Then bank=2
		If Enemy\mx>=2 Then bank=1
		If Enemy\mx<=-1 Then bank=4
		If Enemy\mx<=-2 Then bank=5
		Enemy\x=Enemy\x+Enemy\mx
		Enemy\y=Enemy\y+Enemy\my
		;suicide defender
		If Enemy\t=1 Then
			If Enemy\x>px+50 Then Enemy\mx=Enemy\mx-(0.010+(0.015*GameLevel)):Goto donemov
			If Enemy\x<px-50 Then Enemy\mx=Enemy\mx+(0.010+(0.015*GameLevel)):Goto donemov
			If Enemy\x>px+25 Then Enemy\mx=Enemy\mx-(0.005+(0.005*GameLevel)):Goto donemov
			If Enemy\x<px-25 Then Enemy\mx=Enemy\mx+(0.005+(0.005*GameLevel)):Goto donemov
			
			If Enemy\x>px And Enemy\x<px+10 Then Enemy\mx=Enemy\mx*0.95:Goto donemov
			If Enemy\x<px And Enemy\x>px-10 Then Enemy\mx=Enemy\mx*0.95:Goto donemov
			
			.donemov
			Enemy\my=Enemy\my+0.005+(0.005*GameLevel)
			If Enemy\mx>3 Then Enemy\mx=3
			If Enemy\mx<-3 Then Enemy\mx=-3
			Enemy\x=Enemy\x+Enemy\mx:Enemy\y=Enemy\y+Enemy\my
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>=5 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1:If Enemy\f>4 Then Enemy\f=1
			EndIf
			Enemy\fdraw=((Bank-1)*4)+(Enemy\f-1)
			DrawImage SuicideDefenderImage,Enemy\x,Enemy\y,Enemy\fdraw
			If Enemy\y>400 Then
				If ImagesCollide(PlayerGunImage,px,py,0,SuicideDefenderImage,Enemy\x,Enemy\y,Enemy\fdraw) And DeathTimer=0 Then
					Delete Enemy:KillPlayer:Goto doneenemies
				EndIf
			EndIf
		EndIf
		;Winged warrior
		If Enemy\t=2 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>8 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>7 Then Enemy\f=1
			EndIf
			If Rand(1,100)=1 Then
				If Rand(1,2)=1 Then Enemy\mxtimer=20 Else Enemy\mxtimer=-20
			EndIf
			If Enemy\x>px Then Enemy\mx=Enemy\mx-0.05
			If Enemy\x<px Then Enemy\mx=Enemy\mx+0.05
			If Enemy\y>290 Then Enemy\mytimer=-10
			If Enemy\y<60 Then Enemy\mytimer=10
			If Enemy\mx>4 Then Enemy\mx=4
			If Enemy\mx<-4 Then Enemy\mx=-4
			If Enemy\my>2.5 Then Enemy\my=2.5
			If Enemy\my<-2.5 Then Enemy\my=-2.5
			If Enemy\mytimer>0 Then 
				Enemy\mytimer=Enemy\mytimer-1
				Enemy\my=Enemy\my+0.05
			EndIf
			If Enemy\mytimer<0 Then 
				Enemy\mytimer=Enemy\mytimer+1
				Enemy\my=Enemy\my-0.05
			EndIf
			If Enemy\mxtimer>0 Then 
				Enemy\mxtimer=Enemy\mxtimer-1
				Enemy\mx=Enemy\mx+0.05
			EndIf
			If Enemy\mxtimer<0 Then 
				Enemy\mxtimer=Enemy\mxtimer+1
				Enemy\mx=Enemy\mx-0.05
			EndIf
			
			Enemy\fdraw=((Bank-1)*7)+(Enemy\f-1)
			DrawImage WingedWarriorImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(Enemy\x,Enemy\y,(Rnd(2,2+GameLevel)/t),t)
		EndIf
		;Tentacled terrorists
		If Enemy\t=3 Or Enemy\t=4 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>4 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>5 Then Enemy\f=1
			EndIf
			
			If Enemy\x>540 Then Enemy\mxtimer=-5
			If Enemy\x<100 Then Enemy\mxtimer=5
			If Enemy\y>290 Then Enemy\mytimer=-5
			If Enemy\y<100 Then Enemy\mytimer=5
			
			If Enemy\mx>5 Then Enemy\mx=5
			If Enemy\mx<-5 Then Enemy\mx=-5
			If Enemy\my>4 Then Enemy\my=4
			If Enemy\my<-4 Then Enemy\my=-4
			
			If Rand(1,100)=1 Then Enemy\mytimer=-20
			If Rand(1,100)=1 Then Enemy\mytimer=20
			If Rand(1,100)=1 Then Enemy\mxtimer=-20
			If Rand(1,100)=1 Then Enemy\mxtimer=20
			
			If Enemy\mytimer>0 Then 
				Enemy\mytimer=Enemy\mytimer-1
				Enemy\my=Enemy\my+0.15
			EndIf
			If Enemy\mytimer<0 Then 
				Enemy\mytimer=Enemy\mytimer+1
				Enemy\my=Enemy\my-0.15
			EndIf
			If Enemy\mxtimer>0 Then 
				Enemy\mxtimer=Enemy\mxtimer-1
				Enemy\mx=Enemy\mx+0.15
			EndIf
			If Enemy\mxtimer<0 Then 
				Enemy\mxtimer=Enemy\mxtimer+1
				Enemy\mx=Enemy\mx-0.15
			EndIf
			
			Enemy\fdraw=(Enemy\f-1)
			If Enemy\t=3 Then 
				DrawImage TentacledTerroristImage(GameLevel),Enemy\x-13,Enemy\y,Enemy\fdraw
				DrawImage TentacledTerroristImage(GameLevel),Enemy\x+13,Enemy\y,Enemy\fdraw
			EndIf
			If Enemy\t=4 Then DrawImage TentacledTerroristImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(Enemy\x,Enemy\y,(Rnd(2,2+GameLevel)/t),t)
		EndIf
		;Amoeba motions
		If Enemy\t=5 Or Enemy\t=6 Or Enemy\t=7 Then
			If Enemy\x>560 Then Enemy\mxtimer=-5
			If Enemy\x<80 Then Enemy\mxtimer=5
			If Enemy\y>290 Then Enemy\mytimer=-5
			If Enemy\y<100 Then Enemy\mytimer=5
			
			m#=2+((Enemy\t-5)*1.5)
			If Enemy\mx>m Then Enemy\mx=m
			If Enemy\mx<-m Then Enemy\mx=-m
			If Enemy\my>m Then Enemy\my=m
			If Enemy\my<-m Then Enemy\my=-m
			
			If Rand(1,200)=1 Then Enemy\mytimer=-20
			If Rand(1,200)=1 Then Enemy\mytimer=20
			If Rand(1,200)=1 Then Enemy\mxtimer=-20
			If Rand(1,200)=1 Then Enemy\mxtimer=20
			
			m#=0.1*(Enemy\t-4)
			If Enemy\mytimer>0 Then 
				Enemy\mytimer=Enemy\mytimer-1
				Enemy\my=Enemy\my+m
			EndIf
			If Enemy\mytimer<0 Then 
				Enemy\mytimer=Enemy\mytimer+1
				Enemy\my=Enemy\my-m
			EndIf
			If Enemy\mxtimer>0 Then 
				Enemy\mxtimer=Enemy\mxtimer-1
				Enemy\mx=Enemy\mx+m
			EndIf
			If Enemy\mxtimer<0 Then 
				Enemy\mxtimer=Enemy\mxtimer+1
				Enemy\mx=Enemy\mx-m
			EndIf
		EndIf
		;Large amoeba
		If Enemy\t=5 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>7 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>8 Then Enemy\f=1
			EndIf
			Enemy\fdraw=(Enemy\f-1)
			DrawImage LargeAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(Enemy\x,Enemy\y,(Rnd(2,2+GameLevel)/t),t)
		EndIf
		;Medium amoeba
		If Enemy\t=6 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>5 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>6 Then Enemy\f=1
			EndIf
			Enemy\fdraw=(Enemy\f-1)
			DrawImage MediumAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(Enemy\x,Enemy\y,(Rnd(2,2+GameLevel)/t),t)
		EndIf
		;Small amoeba
		If Enemy\t=7 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>3 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>4 Then Enemy\f=1
			EndIf
			Enemy\fdraw=(Enemy\f-1)
			DrawImage SmallAmoebaImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Rand(1,125-(Gamelevel*15))=1 Then AddMoonBomb(Enemy\x,Enemy\y,(Rnd(2,2+GameLevel)/t),t)
		EndIf
		;Space Enemy - front (dragon)     
		If Enemy\t=9 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>5 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>6 Then Enemy\f=1
			EndIf
			If Enemy\formation=False Then
				maxyspeed#=(2+(GameLevel*0.5))
				maxxspeed#=(6+GameLevel)/2
				If Enemy\my<=maxyspeed Then Enemy\my=Enemy\my+0.025
				If Enemy\y>500 Then Enemy\y=-70
				If Enemy\x>px And Enemy\mxtimer=0 Then Enemy\mx=Enemy\mx-(0.0333*GameLevel)
				If Enemy\x<px And Enemy\mxtimer=0 Then Enemy\mx=Enemy\mx+(0.0333*GameLevel)
				If Enemy\mx>maxxspeed Then Enemy\mx=maxxspeed
				If Enemy\mx<-maxxspeed Then Enemy\mx=-maxxspeed
				If Rand(1,50)=1 Then 
					If Rand(1,2)=1 Then Enemy\mxtimer=Rand(3,10) Else Enemy\mxtimer=Rand(-10,-3)
				EndIf
				If Enemy\mxtimer>0 Then 
					Enemy\mxtimer=Enemy\mxtimer-1
					Enemy\mx=Enemy\mx+(0.025*GameLevel)
				EndIf
				If Enemy\mxtimer<0 Then 
					Enemy\mxtimer=Enemy\mxtimer+1
					Enemy\mx=Enemy\mx-(0.025*GameLevel)
				EndIf
				If Enemy\y<=320 Then
					If Rand(1,100)=1 Then
						ang=ATan2(px-Enemy\x,py-Enemy\y)
						AddSpaceBomb(Enemy\x,Enemy\y,5*Sin(-ang+180),5*-Cos(-ang+180),1)
					EndIf
				EndIf
			EndIf
			Enemy\fdraw=((Bank-1)*6)+(Enemy\f-1)
			DrawImage SpaceFrontImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Enemy\y>400 Then
				If ImagesCollide(PlayerGunImage,px,py,0,SpaceFrontImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw) And DeathTimer=0 Then
					Delete Enemy:KillPlayer:Goto doneenemies
				EndIf
			EndIf
		EndIf
		;Space Enemy - middle (dragonfly)    
		If Enemy\t=10 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>2 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>4 Then Enemy\f=1
			EndIf
			If Enemy\formation=False Then
				maxyspeed#=(2+(GameLevel*0.5))
				maxxspeed#=(6+GameLevel)/2
				If Enemy\my<=maxyspeed Then Enemy\my=Enemy\my+0.025
				If Enemy\y>500 Then Enemy\y=-70
				If Enemy\x>px And Enemy\mxtimer=0 Then Enemy\mx=Enemy\mx-(0.0333*GameLevel)
				If Enemy\x<px And Enemy\mxtimer=0 Then Enemy\mx=Enemy\mx+(0.0333*GameLevel)
				If Enemy\mx>maxxspeed Then Enemy\mx=maxxspeed
				If Enemy\mx<-maxxspeed Then Enemy\mx=-maxxspeed
				If Rand(1,50)=1 Then 
					If Rand(1,2)=1 Then Enemy\mxtimer=Rand(3,10) Else Enemy\mxtimer=Rand(-10,-3)
				EndIf
				If Enemy\mxtimer>0 Then 
					Enemy\mxtimer=Enemy\mxtimer-1
					Enemy\mx=Enemy\mx+(0.025*GameLevel)
				EndIf
				If Enemy\mxtimer<0 Then 
					Enemy\mxtimer=Enemy\mxtimer+1
					Enemy\mx=Enemy\mx-(0.025*GameLevel)
				EndIf
				If Enemy\y<=320 Then
					If Rand(1,100)=1 Then
						ang=ATan2(px-Enemy\x,py-Enemy\y)
						AddSpaceBomb(Enemy\x,Enemy\y,5*Sin(-ang+180),5*-Cos(-ang+180),1)
					EndIf
				EndIf
			EndIf
			Enemy\fdraw=((Bank-1)*4)+(Enemy\f-1)
			DrawImage SpaceMiddleImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If Enemy\y>400 Then
				If ImagesCollide(PlayerGunImage,px,py,0,SpaceMiddleImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw) And DeathTimer=0 Then
					Delete Enemy:KillPlayer:Goto doneenemies
				EndIf
			EndIf
		EndIf
		;Space Enemy - rear (jellyfish)
		If Enemy\t=11 Then
			Enemy\ft=Enemy\ft+1
			If Enemy\ft>4 Then
				Enemy\ft=0:Enemy\f=Enemy\f+1
				If enemy\f>4 Then Enemy\f=1
			EndIf
			Enemy\fdraw=(Enemy\f-1)
			DrawImage SpaceRearImage(GameLevel),Enemy\x,Enemy\y,Enemy\fdraw
			If NumSpaceEnemies<=10 And Rand(1,100)=1 Then Enemy\shooting=Rand(10,25)
			If Rand(1,200)=1 And Enemy\shooting=0 Then Enemy\shooting=1
			If Enemy\shooting>0 Then
				ang=ATan2(px-Enemy\x,py-Enemy\y)+Rand(-5,5)
				AddSpaceBomb(Enemy\x,Enemy\y,5*Sin(-ang+180),5*-Cos(-ang+180),1)
				Enemy\shooting=Enemy\shooting-1
			EndIf
		EndIf
		.doneenemies
	Next
End Function

Function ResetDemonBases(resetarmors)
	For a=0 To 2:B1FireFrame(a)=Rand(0,32):Next
	For a=0 To 3:B2FireFrame(a)=Rand(0,32):Next
	For a=1 To 17:B2WindowFrame(a)=Rand(1,3):Next
	For a=0 To 15:B3FireFrame(a)=Rand(0,32):Next
	B1FireTimer=0:B1RotWindPos=0
	B2RotShieldPos=0:B2FireTimer=0
	B3FireTimer=0:B3RotShieldPos=0:B3RotWindPos=0
	For a=1 To 32:B3WindowColor(a)=Rand(0,255):Next
	For a=1 To 2:B3GunExist(a)=True:B3GunsTimer(a)=0:Next
	B4HeartFrame=0:B4HeartTimer=0:B4HeartCycle=0
	For a=1 To 50
		B4ShieldY(a)=Rand(150,230)
		x1=Int(270-(1.5*(B4ShieldY(a)-149)))   ;old 1.7
		x2=Int(370+(1.5*(B4ShieldY(a)-149)))
		B4ShieldX(a)=Rand(x1,x2)
		B4ShieldType(a)=Rand(1,3):B4ShieldTimer(a)=0
	Next
	For a=1 To 40:B4WindowFrame(a)=Rand(1,3):B4WindowTimer(a)=Rand(1,9):Next
	B5BubblingFrame=Rand(0,3):B5BubblingTimer=0:B5GeneratorFrame=0:B5GeneratorTimer=4:B5ExtraShieldOn=True
	B5RotWindPos=0:B5RotShieldPos=0
	For a=1 To 2:B5OddAngle(a)=Rand(0,180):B5GeneratorExist(a)=True:Next
	For a=1 To 16:For b=1 To 2:B5ProtectorAng(b,a)=((a-1)*21)+B5OddAngle(b):Next:Next
	For a=1 To 5:B5EyeMX(a)=0:B5EyeMY(a)=0:B5EyeRX(a)=0:B5EyeRY(a)=0:B5EyeTimer(a)=0:Next
	For a=1 To 6:B6FireFrame(a)=Rand(0,32):Next
	B6FireTimer=0:B6GenFrame=0:B6GenTimer=0:B6RotWindPos=0:B6RotWindPos2=0
	For a=1 To 2:GenExist(a)=True:For b=1 To 2:GunsExist(a,b)=True:GunsTimer(a,b)=0:GunsShooting(a,b)=0:Next:Next
	For a=1 To 50
		B6ShieldX(a)=Rand(170,460):B6ShieldY(a)=Rand(215,300)
		B6ShieldTimer(a)=0:B6ShieldType(a)=Rand(1,3)
	Next
	B6WindDir=2:B6WindDirTimer=0
	
	;RESET DEMON BASES ARMORS
	If resetarmors=True Then
		B1ArmorImage=LoadImage("Gfx\Demon Bases\B1 - Armor.png")
		B2RotatingShieldImage=LoadImage("Gfx\Demon Bases\B2 - Rotating Shield.png")
		B3RotatingShieldImage=LoadImage("Gfx\Demon Bases\B3 - Rotating Shield.png")
		B4ArmorImage=LoadImage("Gfx\Demon Bases\B4 - Armor.png")
		B5RotatingShieldImage=LoadImage("Gfx\Demon Bases\B5 - Rotating Shield.png")
	EndIf	
End Function

Function UpdateDemonBase(b,pos,shoot)
	If shoot=True Then 
		If Rand(1,500)=1 Then PlaySound EvilLaughSound(Rand(1,5))
	EndIf
	If b=1 Then
		B1FireTimer=B1FireTimer+1
		If B1FireTimer>2 Then
			B1FireTimer=0
			For f=0 To 2
				B1FireFrame(f)=B1FireFrame(f)+1
				If B1FireFrame(f)>32 Then B1FireFrame(f)=0
			Next
		EndIf
		
		B1RotWindPos=B1RotWindPos+1
		If B1RotWindPos>405 Then B1RotWindPos=0
		
		DrawImage B1MouthInteriorImage,227,92+pos
		For f=0 To 2
			DrawImage FireImage(1),300+(15*f),136+pos,B1FireFrame(f)
		Next
		DrawImage B1HeadImage,92,6+pos
		Color 0,0,0:Rect 119,137+pos,406,52,True
		DrawImage B1ArmorImage,121,189+pos
		DrawImage B1LeftEndImage,23,137+pos
		DrawImage B1RightEndImage,525,137+pos
		DrawImageRect B1RotatingWindowImage,119+B1RotWindPos,137+pos,0,0,406-B1RotWindPos,52
		DrawImageRect B1RotatingWindowImage,119,137+pos,405-B1RotWindPos,0,B1RotWindPos,52
		
		;Suicide Defenders
		If Rand(1,30)=1 And shoot=True Then 
			w=119+B1RotWindPos+200
			If w>525 Then w=w-405
			AddEnemy(1,w,180)
		EndIf
	EndIf
	If b=2 Then
		B2FireTimer=B2FireTimer+1
		If B2FireTimer>4 Then
			B2FireTimer=0
			For f=0 To 3
				B2FireFrame(f)=B2FireFrame(f)+1
				If B2FireFrame(f)>32 Then B2FireFrame(f)=0
			Next
		EndIf
		For f=0 To 3
			DrawImage FireImage(1),295+(15*f),159+pos,B2FireFrame(f)
		Next
		
		DrawImage B2CityAndHornsImage,151,6+pos
		
		For a=1 To 17
			If Rand(1,10)=1 Then B2WindowFrame(a)=Rand(1,3)
			DrawImage B2CityWindowsImage,B2WindowX(a),B2WindowY(a)+pos,B2WindowFrame(a)-1
		Next
		
		B2RotShieldPos=B2RotShieldPos+1
		If B2RotShieldPos>337 Then B2RotShieldPos=0
		DrawImageRect B2RotatingShieldImage,151+B2RotShieldPos,177+pos,0,0,338-B2RotShieldPos,86
		DrawImageRect B2RotatingShieldImage,151,177+pos,337-B2RotShieldPos,0,B2RotShieldPos,86
		DrawImage B2LeftHornImage,23,159+pos
		DrawImage B2RightHornImage,488,159+pos
		
		;Suicide Defenders
		If Rand(1,25)=1 And shoot=True Then AddEnemy(1,Rand(240,420),Rand(90,160))
	EndIf 
	If b=3 Then
		B3FireTimer=B3FireTimer+1
		If B3FireTimer>1 Then
			B3FireTimer=0
			For f=0 To 15
				B3FireFrame(f)=B3FireFrame(f)+1
				If B3FireFrame(f)>32 Then B3FireFrame(f)=0
			Next
		EndIf
		For f=0 To 15
			DrawImage FireImage(1),220+(15*f),170+pos,B3FireFrame(f)
		Next
	
		DrawImage B3HeadImage,84,3+pos
		For a=1 To 32
			If Rand(1,20)=1 Then B3WindowColor(a)=Rand(0,255)
			Color 255,B3WindowColor(a),B3WindowColor(a)
			Plot B3WindowX(a),B3WindowY(a)+pos		
		Next
		
		For a=1 To 2
			;xxx=B3LeftGunImage
			If a=2 Then xxx=B3RightGunImage Else xxx=B3LeftGunImage
			If B3GunExist(a)=True Then DrawImage xxx,B3GunX(a),183+pos
		Next
		;DrawImage B3RightGunImage,544,183
		;DrawImage B3LeftGunImage,25,183

		
		B3RotShieldPos=B3RotShieldPos+1
		If B3RotShieldPos>332 Then B3RotShieldPos=0
		DrawImageRect B3RotatingShieldImage,155+B3RotShieldPos,193+pos,0,0,333-B3RotShieldPos,72
		DrawImageRect B3RotatingShieldImage,155,193+pos,332-B3RotShieldPos,0,B3RotShieldPos,72
		
		B3RotWindPos=B3RotWindPos-1
		If B3RotWindPos<0 Then B3RotWindPos=332
		DrawImageRect B3RotatingWindowImage,155+B3RotWindPos,179+pos,0,0,333-B3RotWindPos,14
		DrawImageRect B3RotatingWindowImage,155,179+pos,B3RotShieldPos-1,0,332,14

		DrawImage B3LeftEndImage,85,179+pos
		DrawImage B3RightEndImage,487,179+pos

		
		;Suicide Defenders
		aa=Rand(1,40)
		If B3GunExist(1)=False And B3GunExist(2)=False Then aa=Rand(1,25)
		If aa=1 Then 
			w=155+B3RotWindPos+160
			If w>484 Then w=w-332
			If Shoot=True Then AddEnemy(1,w,180)
		EndIf

		;Dead guns
		For a=1 To 2
			If B3GunExist(a)=False Then
				B3GunsTimer(a)=B3GunsTimer(a)-1
				If B3GunsTimer(a)=0 Then B3GunExist(a)=True
			EndIf
		Next

		;Guns firing
		For a=1 To 2
			If B3GunExist(a)=True And Rand(1,20)=1 And Shoot=True Then
				ang=ATan2(px-(B3GunX(a)+35),py-210)+Rand(-10,10)
				AddSpaceBomb(B3GunX(a)+35,210,5*Sin(-ang+180),5*-Cos(-ang+180),2)
				;AddExplosion(B3GunX(a)+35,210,4,5)
			EndIf
		Next
	EndIf

	If b=4 Then
		DrawImage B4CityAndHornsImage,53,9+pos
		For a=1 To 40
			DrawImage B4CityWindowsImage,B4WindowX(a),B4WindowY(a)+pos,B4WindowFrame(a)-1
			B4WindowTimer(a)=B4WindowTimer(a)+1
			If B4WindowTimer(a)>10 Then
				B4WindowTimer(a)=0
				B4WindowFrame(a)=B4WindowFrame(a)+1
				If B4WindowFrame(a)>4 Then B4WindowFrame(a)=1
			EndIf
		Next
		
		B4HeartTimer=B4HeartTimer+1
		If B4HeartTimer>10 Then
			B4HeartTimer=0
			B4HeartFrame=B4HeartFrame+1
			If B4HeartFrame>3 Then B4HeartFrame=0
		EndIf
		B4HeartCycle=B4HeartCycle+1
		If B4HeartCycle>359 Then B4HeartCycle=B4HeartCycle-360
		DrawImage B4HeartImage,258+(100*Sin(B4heartCycle))     ,82+pos,B4HeartFrame
		For a=1 To 50
			If B4ShieldTimer(a)=0 Then DrawImage B4ShieldPiecesImage,B4ShieldX(a),B4ShieldY(a)+pos,B4ShieldType(a)-1
			If Rand(1,10)=1 Then B4ShieldType(a)=Rand(1,3)
			If B4ShieldTimer(a)>0 Then B4ShieldTimer(a)=B4ShieldTimer(a)-1
		Next
		DrawImage B4ArmorImage,89,239+pos
		;Suicide defenders
		If Rand(1,30)=1 And Shoot=True Then
			AddEnemy(1,Rand(200,470),Rand(40,120))
		EndIf
	EndIf

	If b=5 Then
		B5RotShieldPos=B5RotShieldPos+1
		If B5RotShieldPos>391 Then B5RotShieldPos=0
		DrawImageRect B5RotatingShieldImage,124+B5RotShieldPos,171+pos,0,0,392-B5RotShieldPos,47
		DrawImageRect B5RotatingShieldImage,124,171+pos,391-B5RotShieldPos,0,B5RotShieldPos,47

		B5RotWindPos=B5RotWindPos-1
		If B5RotWindPos<0 Then B5RotWindPos=391
		DrawImageRect B5RotatingWindowImage,124+B5RotWindPos,141+pos,0,0,392-B5RotWindPos,30
		DrawImageRect B5RotatingWindowImage,124,141+pos,B5RotShieldPos-1,0,392,30

		DrawImage B5YellowEyeScreenImage,153,30+pos
		
		;Eyes!!
		;B5EyeBX(5),B5EyeBY(5),B5EyeMX(5),B5EyeMY(5),B5EyeTimer(5)		
		For a=1 To 5
			If Rand(1,20)=1 And B5EyeTimer(a)=0 Then
				B5EyeTimer(a)=Rand(10,40)
				B5EyeMX(a)=Rnd(-0.5,0.5):B5EyeMY(a)=Rnd(-0.5,0.5)
			EndIf
			If B5EyeTimer(a)>0 Then
				B5EyeTimer(a)=B5EyeTimer(a)-1
				B5EyeRX(a)=B5EyeRX(a)+B5EyeMX(a)
				B5EyeRY(a)=B5EyeRY(a)+B5EyeMY(a)
				If B5EyeRX(a)>10 Then B5EyeRX(a)=10
				If B5EyeRX(a)<-10 Then B5EyeRX(a)=-10
				If B5EyeRY(a)>10 Then B5EyeRY(a)=10
				If B5EyeRY(a)<-10 Then B5EyeRY(a)=-10
			EndIf
			DrawImage B5EyeballImage,B5EyeBX(a)+B5EyeRX(a),B5EyeBY(a)+B5EyeRY(a)+pos
		Next
		DrawImage B5EyeGlintImage,464,82+pos
		DrawImage B5EyeGlintImage,405,82+pos
		DrawImage B5EyeGlintImage,195,99+pos
		DrawImage B5EyeGlintImage,299,53+pos
		DrawImage B5EyeGlintImage,209,47+pos
		
		
		B5BubblingTimer=B5BubblingTimer+1
		If B5BubblingTimer>5 Then
			B5BubblingTimer=0
			B5BubblingFrame=B5BubblingFrame+1
			If B5BubblingFrame>3 Then B5BubblingFrame=0
		EndIf
		DrawImage B5BubblingImage,255,127+pos,B5BubblingFrame
		DrawImage B5HeadImage,110,7+pos
		DrawImage B5RightSideImage,515,141+pos
		DrawImage B5LeftSideImage,85,141+pos
		If B5GeneratorExist(1)=True Or B5GeneratorExist(2)=True Then DrawImage B5ExtraShieldImage,118,218+pos
		
		If B5GeneratorExist(1)=True Then DrawImage B5RotatingGeneratorImage,29,108+pos,B5GeneratorFrame
		If B5GeneratorExist(2)=True Then DrawImage B5RotatingGeneratorImage,554,108+pos,B5GeneratorFrame
		B5GeneratorTimer=B5GeneratorTimer+1
		If B5GeneratorTimer>5 Then
			B5GeneratorTimer=0
			B5GeneratorFrame=B5GeneratorFrame+1
			If B5GeneratorFrame>5 Then B5GeneratorFrame=0
		EndIf
		For a=1 To 2
			If B5GeneratorExist(a)=True Then
				For b=1 To 15
					B5ProtectorAng(a,b)=B5ProtectorAng(a,b)+2
					If B5ProtectorAng(a,b)>360 Then B5ProtectorAng(a,b)=B5ProtectorAng(a,b)-360
					If B5ProtectorAng(a,b)<0 Then B5ProtectorAng(a,b)=B5ProtectorAng(a,b)+360
					x=47
					If a=2 Then x=572
					B5ProtectorX(a,b)=70*Sin(B5ProtectorAng(a,b))+x
					B5ProtectorY(a,b)=70*-Cos(B5ProtectorAng(a,b))+128
					DrawImage B5GeneratorDefenderImage,B5ProtectorX(a,b),B5ProtectorY(a,b)+pos,0
				Next
				If Rand(1,10)=1 And Shoot=True Then
					ang=ATan2(px-x,py-128)+Rand(-10,10)
					AddSpaceBomb(x+10,128,5*Sin(-ang+180),5*-Cos(-ang+180),2)
				EndIf
			EndIf
		Next
		
		;Eyes Shooting!
		If B5GeneratorExist(1)=False And B5GeneratorExist(2)=False And DeathTimer=0 And Shoot=True Then
			For a=1 To 5
				If Rand(1,150)=1 Then
					ang=ATan2(px-B5EyeBX(a),py-B5EyeBY(a))+Rand(-10,10)
					AddSpaceBomb(B5EyeBX(a),B5EyeBY(a),5*Sin(-ang+180),5*-Cos(-ang+180),2)
					AddExplosion(B5EyeBX(a),B5EyeBY(a),4,5)
				EndIf
			Next
		EndIf
		
		;Suicide Defenders
		ss=Rand(1,40)
		If B5GeneratorExist(1)=False And B5GeneratorExist(2)=False Then ss=Rand(1,20)
		If ss=1 Then
			sx=124+B5RotWindPos+198
			If sx>515 Then sx=sx-391
			If Shoot=True Then AddEnemy(1,sx,150)
		EndIf
	EndIf

	If b=6 Then
		B6FireTimer=B6FireTimer+1
		If B6FireTimer>2 Then
			B6FireTimer=0
			For f=0 To 6
				B6FireFrame(f)=B6FireFrame(f)+1
				If B6FireFrame(f)>32 Then B6FireFrame(f)=0
			Next
		EndIf
		For f=0 To 6
			DrawImage FireImage(1),282+(10*f),169+pos,B6FireFrame(f)
		Next
		B6GenTimer=B6GenTimer+1
		If B6GenTimer>8 Then
			B6GenTimer=0
			B6GenFrame=B6GenFrame+1
			If B6GenFrame>3 Then B6GenFrame=0
		EndIf
		
		For a=1 To 50
			If B6ShieldTimer(a)>0 Then B6ShieldTimer(a)=B6ShieldTimer(a)-1
			If B6ShieldTimer(a)=0 Then DrawImage B6ShieldPiecesImage,B6ShieldX(a),B6ShieldY(a)+pos,B6ShieldType(a)-1
			If Rand(1,20)=1 Then B6ShieldType(a)=Rand(1,3)
		Next
		
		If GenExist(2)=True Then DrawImage B6GlowingGeneratorImage,414,141+pos,B6GenFrame
		If GenExist(1)=True Then DrawImage B6GlowingGeneratorImage,169,141+pos,B6GenFrame
		If GenExist(1)=True Or GenExist(2)=True Then DrawImage B6ReactorGuardImage,279,163+pos
		For a=1 To 2:For b=1 To 2
			If a=1 And GunsExist(a,b)=True Then DrawImage B6LeftGunImage,GunsX(a,b),GunsY(a,b)+pos
			If a=2 And GunsExist(a,b)=True Then DrawImage B6RightGunImage,GunsX(a,b),GunsY(a,b)+pos
		Next:Next
		DrawImage B6HeadAndHornsImage,8,3+pos

		B6RotWindPos2=B6RotWindPos2+2
		If B6RotWindPos2>296 Then B6RotWindPos2=0
		If B6RotWindPos2<-296 Then B6RotWindPos2=0
		
		;If Rand(1,10)=1 Then B6WindDir=B6WindDir*-1;B6WindDir=2
		B6RotWindPos=B6RotWindPos+B6WindDir

		If B6RotWindPos<0 Then B6RotWindPos=B6RotWindPos+296
		If B6RotWindPos>296 Then B6RotWindPos=B6RotWindPos-296

		B6WindDirTimer=B6WindDirTimer+2
		If B6WindDirTimer>274 Then
			B6WindDirTimer=0
			B6WindDir=B6WindDir*-1
		EndIf

		DrawImageRect B6RotatingWindowImage,171+B6RotWindPos,170+pos,0,0,297-B6RotWindPos,41
		DrawImageRect B6RotatingWindowImage,171,170+pos,296-B6RotWindPos,0,B6RotWindPos,41
		
		DrawImage B6LeftEndImage,145,171+pos
		DrawImage B6RightEndImage,468,171+pos
		
		;Guns firing
		For a=1 To 2:For b=1 To 2
			If Rand(1,250)=1 Then GunsShooting(a,b)=Rand(2,7)
			If GunsExist(a,b)=True And (Rand(1,50)=1 Or GunsShooting(a,b)>0) Then
				ang=ATan2(px-GunsX(a,b),py-GunsY(a,b))+Rand(-5,5)
				If Shoot=True Then AddSpaceBomb(GunsX(a,b)+13,GunsY(a,b)+13,5*Sin(-ang+180),5*-Cos(-ang+180),2)
				;AddExplosion(GunsX(a,b)+13,GunsY(a,b)+13,4,5)
				GunsShooting(a,b)=GunsShooting(a,b)-1
				If GunsShooting(a,b)<0 Then GunsShooting(a,b)=0
			EndIf
		Next:Next
		
		;Dead guns
		For a=1 To 2:For b=1 To 2
			If GunsExist(a,b)=False Then
				GunsTimer(a,b)=GunsTimer(a,b)+1
				If GunsTimer(a,b)>750 Then GunsTimer(a,b)=0:GunsExist(a,b)=True
			EndIf
		Next:Next
		
		;Suicide defenders
		If Rand(1,35)=1 And Shoot=True Then AddEnemy(1,185+B6RotWindPos,180)
	EndIf
End Function

Function SetGammaIntensity(n)
	For a=0 To 255
		b=a+n
		If b<0 Then b=0
		If b>255 Then b=255
		SetGamma a,a,a,b,b,b
	Next
	UpdateGamma
End Function